# omnibus-chef-manage cookbook

Cookbook to configure the Chef Manage addon for Enterprise Chef. The default
recipe is run by Chef Solo when you do `chef-manage-ctl reconfigure`.

## Testing

[ChefDK](https://downloads.chef.io/chef-dk/) (version 0.4.0 at the time of this
writing) is used for test infrastructure.

### Unit Tests

Unit tests use [RSpec](http://rspec.info/) and
[ChefSpec](http://code.sethvargo.com/chefspec/).
Run them with `chef exec rspec`. They are located in the spec/unit directory.

### Integration Tests

Integration tests for the cookbook can be run with
[Test Kitchen](http://kitchen.ci/).

The development suite won't do much unless it is given a path to a chef-manage
package to install. The
`node['chef-manage']['development']['chef_manage_deb_package_path']` and/or
`node['chef-manage']['development']['chef_manage_rpm_package_path']`
attributes should point at a package on the Kitchen instance's local filesystem.
This can be set under `suites.attributes` in .kitchen.local.yml.

In Test Kitchen using Vagrant (the default), the root of the chef-manage
project will be mounted at /mnt/chef-manage.

Running `kitchen test` will bring up the instance and install Chef server
and the Manage add on. It will symlink the cookbooks from Test Kitchen's
temporary directory (which were just copied from your local machine) and run
`chef-manage-ctl reconfigure` to converge with this cookbook's default recipe.
Then it runs tests to verify if it's working.

See the Test Kitchen documentation for more commands you can use.

## Author

Author:: Nathan L Smith <smith@chef.io>
