# Represents a config file (/etc/opscode-manage/manage.rb, for example), and
# has helper methods for reading attributes about it
module Manage
  class ConfigFile
    attr_reader :path

    def initialize(filename)
      @path = filename
    end

    def exist?
      @exist ||= File.exist?(path)
    end

    def non_empty?
      @empty ||= exist? && !File.zero?(path)
    end

    def regular_file?
      @regular_file ||= exist? && !File.symlink?(path)
    end
  end
end
