module Manage
  module Helpers
    def chef_server_external_url(node)
      chef_server_url(node, node['private_chef']['lb']['api_fqdn'])
    end

    def chef_server_internal_url(node)
      chef_server_url(node, "localhost")
    end

    def chef_server_url(node, host)
      url = "https://#{host}"
      ssl_port = node['private_chef']['nginx']['ssl_port']
      url += ":#{ssl_port}" if ssl_port != 443
      url
    end

    def should_notify?(service)
      node['chef-manage']['services'][service]['enable'] &&
        OmnibusHelper.should_notify?(service,
                                     node['chef-manage']['install_path'],
                                     'chef-manage-ctl')
    end

    # Should we use a standalone server or use the same server as the API?
    def use_standalone_nginx_server?(node)
      node['chef-manage']['fqdn'] != node['private_chef']['lb']['api_fqdn'] ||
      node['chef-manage']['public_port'] != node['private_chef']['nginx']['ssl_port']
    end
  end
end
