#
# Cookbook Name:: omnibus-chef-manage
# Recipe:: redis
#
# Copyright:: Copyright (c) 2013-2015 Chef Software, Inc.
# License:: Apache License, Version 2.0
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

include_recipe 'omnibus-chef-manage::config'

app = node['chef-manage']
redis_conf = ::File.join(app['config_path'], 'redis.conf')
redis_lib_path = ::File.join(app['var_path'], 'lib/redis')
redis_log_path = ::File.join(app['log_path'], 'redis')

[redis_lib_path, redis_log_path].each do |path|
  directory path do
    mode '0700'
    owner app['user']['username']
    recursive true
  end
end

template redis_conf do
  source 'redis.conf.erb'
  mode '0600'
  owner app['user']['username']
  notifies :restart, 'component_runit_service[redis]'
  variables({
    :pidfile => ::File.join(app['var_path'], 'run/redis.pid'),
    :port    => app['redis']['port'],
    :dir     => redis_lib_path
  })
end

component_runit_service 'redis' do
  package node['enterprise']['name']
end
