#
# Cookbook Name:: omnibus-chef-manage
# Recipe:: show_config
#
# Copyright:: Copyright (c) 2017 Chef Software, Inc.
# License:: Apache License, Version 2.0
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

config_path = '/etc/chef-manage'
config_file = "#{config_path}/manage.rb"
running_config = ::File.join(node["chef-manage"]["config_path"], "chef-manage-running.json")

# Load the running config
if File.exists?(running_config)
  chef_manage = JSON.parse(IO.read(running_config))
  node.consume_attributes({"chef-manage" => chef_manage["chef-manage"]})
end

# Load the config on disk
if File.exists?(config_file)
  Manage::Config.from_file(config_file)
  config = Manage::Config.save(false)
  node.consume_attributes({"chef-manage" => config})
end

puts Chef::JSONCompat.to_json_pretty(node["chef-manage"])
