# private_chef_addon cookbook

*NOTE: This cookbook was an early attempt at unifying the behavior of Chef
server add-ons. It is only used by this cookbook and has been superseded by
the [enterprise cookbook](https://github.com/opscode-cookbooks/enterprise-chef-common).

You should not use this cookbook and implement the functionality directly in
your add-on or use the enterprise cookbook.*

This cookbook creates a provider for common resources for a Private Chef add-on.

# Resource/Providers

This cookbook provides a `private_chef_addon` resource.

## Usage

In a recipe that goes in your add-on's run list, include

    private_chef_addon 'my-addon-name' do
      action :nothing
    end.run_action(:create)

(This is a bit of a hack. The resource sets node attributes. Doing this makes
these attributes set in the initial phase so subsequent resources can use these
attributes.

### Loading Recipes

The provider will look through a hash of attributes provided by you, so
attributes like:

    default['my-addon']['services'] = {
      :one_service     => true,
      :another_service => false
    }

Will load include the `my-addon::one_service` and `my-addon::another_service_disable`
recipes.

## Actions

* *create*: Creates all the resources for an add-on. This is the default action.

## Parameters

* *name*: The name attribute. This is the prefix used for all attributes and resources.

# Author

Author:: Chef Software, Inc. (<cookbooks@chef.io>)
