# Configuration for Stickit bindings
define (require) ->
  Stickit = require('backbone.stickit')

  # Set up a stickit handler to record the reverse binding maps to be used from
  # our validation callbacks
  Stickit.addHandler
    selector: '*'
    initialize: ($el, model, options) ->
      return unless model.validation
      model.reverseBindings ?= {}
      model.reverseBindings[options.observe] = $el

  # Set up a stickit handler to block forms from being overwritten if the user
  # types something in the time between page load and stickit binding. This
  # handler must be last because stickit injects a default updateView:true on all
  # handlers.
  Stickit.addHandler
    # The select:not($signup-job-title) select creates an exception for the
    # job-title dropdown menu because updateView prevents the default update
    # function in backbone.stickit from running for <select> and <option>
    # elements. Thus, validation failed for the dropdown since the <option>
    # values were pre-populated instead of being rendered by stickit.
    selector: 'input,textarea,select:not(#signup-job-title)'
    updateView: ->
      if @initializing?
        not @initializing
      else
        true
