define (require) ->
  Container = require('models/container')
  SlickBack = require('slickback')
  T = require('utils/i18n.gettext')

  # A fake-ish collection that defines containers for permission purposes
  class Containers extends SlickBack.Collection
    model: Container

    initialize: (models, options) ->
      throw 'Do not initialize Containers with any models' if models
      super
      @org = options.organization
      # Some unit tests don't fill in access data, fail safely
      access = @org.get('access') or {}
      containers = [
        {id: 'nodes', label: T('Nodes'), collection: @org.nodes, access: access.nodes}
        {id: 'cookbooks', label: T('Cookbooks'), collection: @org.cookbooks, access: access.cookbooks}
        {id: 'roles', label: T('Roles'), collection: @org.roles, access: access.roles}
        {id: 'data_bags', label: T('Data Bags'), collection: @org.databags, access: access.data}
        {id: 'environments', label: T('Environments'), collection: @org.environments, access: access.environments}
        {id: 'groups', label: T('Groups'), collection: @org.groups, access: access.groups}
      ]
      @reset(c for c in containers when c.access?.grant)

    # No-op because data is fake
    sync: ->

    url: ->
      "#{@org.url()}/global_permissions"
