define ['b', 'models/organization', 'slickback', 'underscore'], (Backbone, Organization, SlickBack, _) ->
  class Organizations extends Backbone.Collection
    _.extend(@::, SlickBack.Collection::)
    model: Organization
    url: -> '/organizations'

    # Like get, but stores the name given as the last org
    getCurrent: (id) ->
      if id
        if window.localStorage
          localStorage.setItem('last-organization', id)
        @_lastOrganization = @get(id)
        @trigger('current:changed', @_lastOrganization)
        @_lastOrganization
      else
        @last()

    # Return the last org that was looked at
    last: ->
      if @_lastOrganization
        @_lastOrganization
      else if window.localStorage and (id = localStorage.getItem('last-organization')) and (@_lastOrganization = @get(id))
        @_lastOrganization
      else
        @_lastOrganization = @at(0)
