define (require) ->
  BasePaginator = require('collections/base')
  Run = require('models/run')

  class Runs extends BasePaginator
    model: Run
    webuiUrl: 'runs'
    # field that indicates if the collection was initialized
    # with url date params or if the default of 24 hours was used
    wasInitialized: false
    selection: null
    set_time_params: (startTime, endTime) ->
      @server_api.startTime = startTime
      @server_api.endTime = endTime
    set_status_param: (status) ->
      @server_api.status = status
    server_api:
      page: -> @currentPage
      count: -> @perPage
      start_row: -> @currentPage * @perPage
      num_rows: -> @perPage # number of new rows we will get this scroll

    # override
    fetchStarted: ->
      super
      @trigger('fetchStarted')

    cleanServerApi: ->
      delete @server_api.startTime
      delete @server_api.endTime
      delete @server_api.status
      delete @server_api.filter
      delete @server_api.env
      @currentPage = 0

    urlWithQueryParams: ->
      url_string = @url() + "?endTime=" + encodeURIComponent(@server_api.endTime) + "&startTime=" + encodeURIComponent(@server_api.startTime)
      if @server_api.filter?
        url_string += "&q=" + encodeURIComponent(@server_api.filter)
      if @server_api.status?
        url_string += "&status=" + encodeURIComponent(@server_api.status)
      if @server_api.env?
        url_string += "&env=" + encodeURIComponent(@server_api.env)
      url_string
