define (require) ->
  Backbone = require('b')
  Comparators = require('models/search/comparators')
  Filters = require('models/search/filters')
  SearchError = require('utils/search_error')
  T = require('utils/i18n.gettext')

  class SearchClauses extends Backbone.Collection
    toJSON: ->
      @map (clause) ->
        {
          filter: clause.name,
          comparator: clause.get('comparator').name,
          value: clause.get('value'),
        }

    addClause: (filter, comparator, value) ->
      filterClass = Filters[filter]
      throw new @SearchError(T('Invalid filter type: %s'), filter) unless filterClass?
      attrs = {}
      if comparator?
        attrs.comparator = Comparators[comparator]
        throw new SearchError(T('Invalid comparator type: %s'), comparator) unless attrs.comparator?
      attrs.value = value if value?
      filterInstance = new filterClass(attrs)
      @add(filterInstance)
      filterInstance

    removeClause: (index) ->
      filter = @at(index)
      throw new SearchError(T('Invalid clause index')) unless filter?
      @remove(filter)
      filter
