define ['text', 'module'], (text, module) ->
  masterConfig = module.config?() ? {}

  _filenameTranslator = (filename) ->
    if filename[0] != '/' and require?.toUrl
      require.toUrl(filename)
    else
      filename

  _readElm = (filename) ->
    elm = document.getElementById(filename.substr(1))
    elm?.value or elm?.textContent or ''

  fsCompat =
    filenameTranslator: (fn) ->
      _filenameTranslator = fn if fn?
      _filenameTranslator

    readFile: (filename, encoding, callback) ->
      if callback?
        callback = encoding
        encoding = null
      return callback(_readElm(filename)) if filename[0] == '#'
      text.get _filenameTranslator(filename), (data) ->
        callback(null, data)

  # Copy pasta from text.js
  if masterConfig.env == 'node' or (not masterConfig.env and
        typeof process != "undefined" and
        process.versions and
        !!process.versions.node)
    # Using special require.nodeRequire, something added by r.js.
    nodeFs = require.nodeRequire('fs')
    fsCompat.readFileSync = (filename, encoding) ->
      url = _filenameTranslator(filename)
      file = nodeFs.readFileSync(url, 'utf8')
      # Remove BOM (Byte Mark Order) from utf8 files if it is there.
      if file.indexOf('\uFEFF') == 0
        file = file.substring(1)
      file
  else if masterConfig.env == 'xhr' or not masterConfig.env
    fsCompat.readFileSync = (filename, encoding) ->
      return _readElm(filename) if filename[0] == '#'
      url = _filenameTranslator(filename)
      xhr = text.createXhr()
      xhr.open('GET', url, false)
      xhr.send(null)
      xhr.responseText
  else
    throw new Error("No Rhino support yet")

  fsCompat
