define (require) ->
  BaseController = require('controllers/base')
  ContainerListView = require('views/containers/list')
  ContainerPermissionsView = require('views/containers/permissions')
  T = require('utils/i18n.gettext')
  i18n = require('utils/i18n')

  class ContainersController extends BaseController
    id: 'containers'
    messages:
      label: -> T('Global Permissions')
      selectEmpty: -> T('Please select a container')
      selectMulti: (n) -> i18n.sprintf(T('%d containers selected'), n)
      showingAllObjects: -> T('Showing all containers')

    listViewClass: ContainerListView

    tabs: [
      {id: 'permissions', label: T('Permissions'), viewClass: ContainerPermissionsView},
    ]

    routes:
      'organizations/:org/global_permissions': 'index'
      'organizations/:org/global_permissions/:id': 'show'
      'organizations/:org/global_permissions/:id/:tabId': 'show.tab'

    checkAccess: (org) ->
      org ||= @app.organizations.last()
      org.containers.length > 0
