define (require) ->
  BaseController            = require('controllers/base')
  CreateDatabagModal        = require('views/databags/modals/create')
  CreateDatabagItemModal    = require('views/databag_items/modals/create')
  Databag                   = require('models/databag')
  DatabagListsView          = require('views/databags/list')
  DataBagItemsView          = require('views/databags/items')
  PermissionsView           = require('views/controls/permissions')
  T                         = require('utils/i18n.gettext')
  _                         = require('underscore')
  i18n                      = require('utils/i18n')

  class DatabagsController extends BaseController
    id: 'databags'
    #special case that required seprate variables in the first place
    endpoint: 'data'
    collection_type: 'databags'
    messages:
      label: (n) -> i18n.ngettext('Data Bag', 'Data Bags', n ? 1)
      selectEmpty: -> T('Please select a Data Bag')
      selectMulti: (n) -> i18n.sprintf(T('%d data bags selected'), n)
      selectMultiItems: (n) ->  i18n.sprintf(T('%d data bag itemss selected'), n)
      delete: (n) -> i18n.ngettext('Delete Data Bag', 'Delete Data Bags', n ? 1)
      deleteItem: (n) -> i18n.ngettext('Delete Data Bag Item', 'Delete Data Bag Items', n ? 1)
      deleteSingle: T('Deleting %s')
      deleteLong: (n) -> i18n.ngettext('You are about to delete %d data bag:', 'You are about to delete %d data bags:', n ? 1)
      searchItemsMessage: T("Search data bag items")
      showingAllObjects: -> T("Showing <strong>All Databags</strong>")
      showingNItems: (n) -> i18n.sprintf(i18n.ngettext('Showing <strong>%d item</strong>', 'Showing <strong>%d items</strong>', n ? 1), n)
      showingAllItems: -> T("Items")
      searchingItems: -> T("Searching items...")

    listViewClass: DatabagListsView

    tabs: [
      {id: 'items', label: T('Items'), viewClass: DataBagItemsView},
      {id: 'permissions', label: T('Permissions'), viewClass: PermissionsView} 
    ]
    actions: [
      {id: 'create', label: T('Create'), always: true, type: 'databag', dropdown: false},
      {id: 'delete', label: T('Delete'), multi: true, type: 'databag'},
      {id: 'createItem', label: T('Create Item'), type: 'databag'}
    ]
    routes:
      'organizations/:org/data_bags': 'index'
      'organizations/:org/data_bags/:id(/:tab)(/:item_id)': 'show'

    route_show: (org, bagId, tabId, itemId) ->
      @currentTabId = tabId
      @initialItemId = itemId

      model = @collection.get(bagId)
      model.items.fetch({reset: true})
      if model? then [model] else []

    action_create: ->
      new CreateDatabagModal(app: @app)

    action_createItem: ->
      new CreateDatabagItemModal(app: @app, databag: @selection.first())
