define (require) ->
  BaseController = require('controllers/base')
  DashboardView = require('views/reporting/dashboard')
  i18n = require('utils/i18n')
  T = require('utils/i18n.gettext')
  Time = require('utils/time',)

  class ReportingDashboardController extends BaseController
    id: 'reporting_dashboard'
    split_pane: false
    messages:
      label: -> T('Dashboard')
    routes:
      'organizations/:org/dashboard':'index'

    url: (org) ->
      org ||= @app.organizations.last()
      org.url() + '/dashboard'

    paneView: ->
      new DashboardView({ app: @app,  baseUrl: @app.organizations.last().url() })

    checkAccess: (org) ->
      org ||= @app.organizations.last()
      org.isFeatureEnabled('reporting')

    route_index: (orgName, params) ->
      if params?.startTime? and params?.endTime?
        @collection.endTime = parseInt(params.endTime, 10)
        @collection.startTime = parseInt(params.startTime, 10)
      # initialize collection params to 24 hours
      else
        @collection.endTime = Math.round( moment.utc().unix() )
        @collection.startTime = Time.daysFromStart( 1, @collection.endTime )
