define (require) ->
  rekey: ->
    # Setting private_key to true causes the server to reset the keys
    @set({ private_key: true }, { silent: true })
    sync = @sync('update', @)

    # When the private key is changed on a sync, it doesn't send the new public
    # key in the response. Re-fetch the user if the key has changed so we can
    # re-render views that display the public key.
    sync.then(@fetch.bind(@))

    # Always unset the private_key property to make sure subsequent requests
    # don't inadvertently reset the key.
    sync.always => @unset('private_key', { silent: true })

    return sync
