define (require) ->
  ACLHelper = require('helpers/acl')
  Backbone = require('b')
  _ = require('underscore')
  validation = require('utils/backbone_validation')

  class BaseModel extends Backbone.Model
    _.extend(@::, ACLHelper)
    _.extend(@::, validation.mixin())

    idAttribute: 'name'

    initialize: ->
      super
      @updateIdField()
      @collection?.on("sync", @updateIdField, @)
      @on("sync", @updateIdField, @)

    updateIdField: ->
      if !@id?.length > 0 and @get('_id')?
        @id = @get('_id')
        # do this, otherwise the defaults value will overwrite
        @set(@idAttribute, @id)

