define (require) ->
  BaseModel = require('models/base')
  CookbookVersion = require('models/cookbook_version')

  class Cookbook extends BaseModel
    defaults:
      versions: []

    initialize: ->
      super
      @cookbookVersions = {}
      @set('displayVersion', @get('current_version'))

    getCookbookVersion: (version) ->
      version ||= @get('current_version')
      @cookbookVersions[version] ||= new CookbookVersion({version: version, cookbook: @})

    currentVersionUrl: ->
      "#{@url()}/#{@get('current_version')}"

    displayVersionModel: ->
      @getCookbookVersion(@get('displayVersion'))
