define (require) ->
  config = require('config')
  RunListParentModel = require('models/run_list_parent')
  moment = require('moment')

  class Run extends RunListParentModel
    idAttribute: 'run_id'
    # run steps collection
    runSteps: null
    initialize: ->
      super
      @set("resource_summary", @get("updated_res_count") + " / " + @get("total_res_count") )

      from = null
      to = null

      if @get("start_time")
        from = moment(@get("start_time"))
        @set("start_time", from)

      if @get("end_time")
        to = moment(@get("end_time"))
        @set("end_time", to)

      # if a run is started or abored, these fields will be empty
      if from? and to?
        diff = to.from(from, true)
        @set("duration", diff)
      else
        @set("duration", "")

    analyticsEnabled: (org) ->
      org.isFeatureEnabled('analytics_links') && !!config.chef_analytics_url

    analyticsUrl: (org) ->
      "#{config.chef_analytics_url}/organizations/#{org.id}/actions?types=node&names=#{@get('node_name')}&before=#{@get('end_time').format('YYYY-MM-DD')}"
