define (require) ->
  BaseModel = require('models/base')
  RunLists  = require('collections/run_lists')

  # This is a model to be inherited by models that deal with run lists.
  #
  # It contains methods that use backbone internals to update the run list
  # when the model is updated. It does this my listening on backbone parse,
  # which is a function that occurs when the model's data is returned by the server,
  # in either fetch or save. That way, the run list will always be updated properly
  # when as the model changes.
  class RunListParentModel extends BaseModel
    parse: (response) ->
      # this will be the case for /collection/:id and not /collection
      if @run_lists().length > 0
        @run_lists().fetch()
      super

    run_lists: ->
      @run_lists_instance ?= new RunLists([], {object: @})
