define (require) ->
  Backbone = require('backbone')
  Clauses = require('collections/search/clauses')
  Comparators = require('models/search/comparators')
  Filters = require('models/search/filters')
  SearchError = require('utils/search_error')

  class Search extends Backbone.Model
    # Expose some classes
    Clauses: Clauses
    Filters: Filters
    Comparators: Comparators
    SearchError: SearchError

    defaults: ->
      clauses: new Clauses
      matchAny: false

    addClause: (filter, comparator, value) ->
      @get('clauses').addClause(filter, comparator, value)

    removeClause: (index) ->
      @get('clauses').removeClause(index)

    toSolr: ->
      solrClauses = @get('clauses').map (clause) -> "( #{clause.toSolr()} )"
      solrClauses.join(if @get('matchAny') then " OR " else " AND ")
