define (require) ->
  Backbone = require('b')
  T = require('utils/i18n.gettext')
  comparators = require('models/search/comparators')

  filters = {}
  add = (filter) -> filters[filter.prototype.name] = filter

  class StringFilter extends Backbone.Model
    View: class View extends Backbone.View
      initialize: ->
        @model.on('change', @render, this)
        @render()

      render: ->
        @$el.html("""<input type="text" name="#{@model.escape('name')}" value="#{@model.escape('value')}" />""")

      # Event Handlers
      events:
        'change input': 'updateValue'

      updateValue: ->
        newVal = @$('input').val()
        @model.set({value: newVal})

    defaults:
      comparator: comparators.contains
      value: ''

    comparators: -> [
      comparators.contains,
      comparators.begins,
      comparators.ends,
    ]

    toSolr: ->
      @get('comparator').toSolr(@field ? @name, @get('value'))

  add class NameFilter extends StringFilter
    name: 'name'
    label: T('Name')

  add class PlatformFilter extends StringFilter
    name: 'platform'
    label: T('Platform')

  add class FQDNFilter extends StringFilter
    name: 'fqdn'
    label: T('FQDN')

  add class IPFilter extends StringFilter
    name: 'ipaddress'
    label: T('IP Address')

  add class EnvironmentFilter extends StringFilter
    name: 'chef_environment'
    label: T('Environment')

  add class RecipesFilter extends StringFilter
    name: 'recipes'
    label: T('Recipes')

  add class RolesFilter extends StringFilter
    name: 'roles'
    label: T('Roles')

  filters
