# This is a model that wraps a user model so you can do validation and updates
# only on the password-related fields
define (require) ->
  Backbone = require('b')
  validation = require('utils/backbone_validation')

  class UserPassword extends Backbone.Model
    _.extend(@::, validation.mixin())

    defaults:
      current_password: ''
      new_password: ''
      new_password_confirmation: ''

    labels:
      new_password_confirmation: 'New password confirmation'

    validation:
      current_password:
        minLength: 6
        maxLength: 50
        required: true
      new_password:
        minLength: 6
        maxLength: 50
        required: true
      new_password_confirmation:
        equalTo: 'new_password'
        msg: 'Passwords must match'

    initialize: (model, options)->
      user = options?.user

      if user
        # Take the attributes from the given user model
        @set(user.attributes, { silent: true })

        # Take the given user model's url property and append /password to it
        @url = -> user.url() + '/password'
