define (require) ->
  Backbone = require('b')

  class Router extends Backbone.Router
    initialize: ->
      super
      @handlers = []
      @handlersByName = {}

    navigate: ->
      # Generate an event on all navigate calls, even when the router won't be triggered
      @trigger('navigate', arguments...)
      super

    route: (route, name, callback) ->
      if _.isRegExp(route)
        rawRoute = null
      else
        rawRoute = route
        route = @_routeToRegExp(route)
      @handlers.unshift({
        name: name,
        raw: rawRoute,
        route: route,
      })
      @handlersByName[name] = rawRoute
      super

  # The router is a singleton. We return the instance
  new Router
