# Based on http://www.quirksmode.org/js/detect.html
define [], ->
  browserInfo =
    Chrome: {}
    Safari:
      string: navigator.vendor
      subString: 'Apple'
      versionSearch: 'Version'
    Opera:
      prop: window.opera
      versionSearch: 'Version'
    Firefox: {}
    IE:
      subString: 'MSIE'

  searchBrowser = ->
    for name, data of browserInfo
      if data.prop
        return name
      candidateString = data.string or navigator.userAgent
      searchString = data.subString or name
      if candidateString?.indexOf(searchString) != -1
        return name

  searchVersion = (name, string) ->
    data = browserInfo[name]
    pattern = new RegExp("#{data.versionSearch or name}\\D*(.*)$")
    if match = string.match(pattern)
      parseFloat(match[1])

  browser = {name: searchBrowser()}
  if browser.name
    browser.version = searchVersion(browser.name, navigator.userAgent) or
                      searchVersion(browser.name, navigator.appVersion)
  browser
