# Port of https://github.com/coderanger/commis/blob/master/commis/utils/dict.py#L3

define ['underscore'], (_) ->
  Pair = (dest, src) ->
    @dest = dest
    @src = src
    @

  isPlainObject = (obj) ->
    typeof obj == 'object' and not _.isArray(obj)

  # deepMerge(objects...): Merge a set of objects together. Input objects as
  # [lowest priority, ..., highest priority]
  (objects...) ->
    dest = {}
    stack = for obj in objects
      new Pair(dest, obj)
    while stack.length
      current = stack.shift()
      current_dest = current.dest
      current_src = current.src
      for key, value of current.src
        if current_dest[key]? and isPlainObject(value) and isPlainObject(current_dest[key])
          stack.push(new Pair(current_dest[key], value))
        else
          current_dest[key] = value
    dest
