define (require) ->
  Backbone = require('b')
  router = require('router')

  class MainNav extends Backbone.Layout
    id: 'mainnav'
    template: require('j!application/mainnav')
    events:
      'click a': 'clickTab'

    initialize: ->
      @app = @options.app
      @currentOrg = @app.organizations.last()

    beforeRender: ->
      @app.off('change:org', null, @)
      @app.on('change:org', @updateOrg, @)
      @tabs = (tab for tab in @app.mainTabs when tab.checkAccess(@currentOrg))

    cleanup: ->
      @app.off(null, null, @)

    serialize: ->
      tabs: for tab in @tabs
              active: tab.id == @activeTab
              url: tab.url(@currentOrg)
              label: _.result(tab.messages, "label")

    clickTab: (evt) ->
      evt.preventDefault()
      $elm = $(evt.currentTarget)
      router.navigate($elm.attr('href'), { trigger: true })

    applyController: (controller) ->
      if controller.parentController?
        controller = controller.parentController
      if controller.id != @activeTab
        @activeTab = controller.id
        @render()

    updateOrg: (org) ->
      @currentOrg = org
      @render()
