define (require)->
  Modal = require('views/controls/modals/base')
  browser = require('utils/browser')

  class BrowserVersionModal extends Modal
    template: require('j!application/modals/browser_version')
    className: "#{@::className} modal-browser-version"
    supportedVersions:
      IE: 9
      Firefox: 20
      Chrome: 26
      Safari: 6
      Opera: 999

    initialize: ->
      if @browserOutdated() and !@checkCookie()
        super

    serialize: ->
      user: @app?.user.get('display_name')
      state: null # Used in the base modal template
      support_email_address: require('config').support_email_address

    cleanup: ->
      @setCookie()
      super

    browserOutdated: ->
      return true if location.search.match(/__force_outdated__/) # For testing
      ver = @supportedVersions[browser.name]
      browser.name and ver and (not browser.version or browser.version < ver)

    checkCookie: ->
      !!document.cookie.match(/chef_manage_browser_warning=true/)

    setCookie: ->
      document.cookie = "chef_manage_browser_warning=true; Expires Fri, 31 Dec 9999 23:59:59 GMT; path=/"
