define (require) ->
  BaseModal = require("views/controls/modals/base")
  Empty = require("views/controls/empty")
  template = require('j!application/modals/master_queue_errors_modal')
  JobQueue = require("services/job_queue")
  require('bootstrap-tooltip')

  class MasterQueueErrorsModal extends BaseModal
    template: template
    className: "#{@::className} modal-request-errors"
    closeButtonText: "Close"
    events:
      "click .fa-refresh":"retryRequest"
      "click .fa-remove-sign":"deleteRequestAttempt"
      "click .btn-clear":"clearAllAndClose"

    initialize: ->
      @masterQueue = @options.app.masterQueue
      @errorQueue = @options.errorQueue
      @retryQueue = new JobQueue()
      super

    cleanup: ->
      @app.usernav?.updateNotificationsUI()
      @app.usernav?.notificationCenter.hide()
      @retryQueue.sendRemainingToDifferentQueue(@masterQueue)

    serialize: ->
      _.extend(super(), {errorArray: @errorQueue.requestArray})

    deleteRequestAttempt: (evt) ->
      evt.preventDefault()
      @removeRequestFromErrors(evt)
      @renderEmpty()

    retryRequest: (evt) ->
      evt.preventDefault()
      failedRequest = @removeRequestFromErrors(evt)
      @retryQueue.queueRequest(failedRequest)
      @renderEmpty()

    renderEmpty: ->
      if @$(".error_entry").length == 0
        @setView(".modal-body", new Empty).render()

    removeRequestFromErrors: (evt) ->
      $elm = $(evt.currentTarget).parent()
      # get and remove the request selected
      $elm.remove()
      request = @errorQueue.removeIndex($elm.index())

    clearAllAndClose: (evt) ->
      evt.preventDefault()
      @$(".error_entry").each( (index, element) =>
        @errorQueue.removeIndex(0)
        @$(element).remove()
      )
      @renderEmpty()
