define (require) ->
  Backbone = require('b')
  Tabs = require('views/controls/tabs')
  _ = require('underscore')
  config = require('config')
  router = require('router')
  template = require('j!application/object_tabs')

  class ObjectTabs extends Tabs
    template: template

    initialize: (@options = {}) ->
      super
      @app = @options.app
      @label = @options.label ? ''
      @model = @options.model ? new Backbone.Model

    tabView: (tab) ->
      args = {model: @model, app: @app}
      if tab.viewArgs
        _.extend(args,
          if _.isFunction(tab.viewArgs)
            tab.viewArgs.apply(@)
          else
            tab.viewArgs
          )
      new tab.viewClass(args)

    serialize: ->
      _.extend(super, {label: @label, model: @model})

    afterRender: ->
      @resize()

    changeTab: (evt) ->
      url = $(evt.currentTarget).find('a').attr('href')
      router.navigate(url)
      super

    resize: ->
      $pane = @$el.parent()
      return if $pane.length == 0
      $tab = @$('.tab-content')
      offset = $tab.offset().top - $pane.offset().top + $pane.scrollTop()
      padding = $tab.outerHeight() - $tab.height()
      minHeight = $pane.height() - offset - padding
      $tab.css('min-height', "#{minHeight}px")
      @currentView?.onResize?()

    urlBase: ->
      try
        @model.url().split('?')[0]
      catch error
        ''
