define (require) ->
  AccordionSection = require('views/controls/accordion_section')
  Backbone = require('b')
  SidebarActions = require('views/application/sidebar/actions')
  router = require('router')
  template = require('j!application/sidebar/section')

  class SidebarSection extends AccordionSection
    @SidebarActions = SidebarActions
    template: template
    actionsViewClass: SidebarActions

    initialize: ->
      super
      @app = @options.app
      @label = @options.label ? ''
      @controller = @options.controller
      @href = @options.href
      @currentOrg = @app?.organizations.last()
      @actions = @options.actions ? []
      @actionsView = new @actionsViewClass({
        selection: @options.selection ? new Backbone.Collection
        actions: @actions
        controller: @controller
      })

    beforeRender: ->
      super
      @off('toggle', null, @)
      @on('toggle', @onToggle, @)
      if @app
        @app.off('change:org', null, @)
        @app.on('change:org', @updateOrg, @)
      @setView('.accordion-body', @actionsView)

    serialize: ->
      hasActions: @actions.length > 0
      label: @label
      href: @url()

    url: ->
      @href or @controller.url(@currentOrg)

    onToggle: ->
      url = @url()
      router.navigate(url, { trigger: true }) if url

    updateOrg: (org) ->
      @currentOrg = org
      @render()
