define (require) ->
  Dropdown = require('views/controls/dropdown')
  router = require('router')
  template = require('j!application/usernav/organization_dropdown')

  class OrganizationDropdown extends Dropdown
    template: template
    pulloutClassName: 'with-icons responsive-header'

    initialize: ->
      @app = @options.app
      @collection = @app.organizations
      @model = @collection.last()
      @options.label = @model.id
      super

    beforeRender: ->
      router.on('all', @updateOrg, @)

    cleanup: ->
      router.off(null, null, @)

    serialize: ->
      data = super
      data.orgs = @collection
      data.org = @model
      data

    numOptions: ->
      @collection.length + 2

    updateOrg: ->
      currentOrg = @collection.last()
      unless currentOrg is @model
        @model = currentOrg
        @label = @model.get('full_name')
        @render()
