define (require)->
  Dropdown = require('views/controls/dropdown')
  T = require('utils/i18n.gettext')
  state = require('state')
  config = require('config')

  class UserDropdown extends Dropdown
    template: require('j!application/usernav/user_dropdown')
    pulloutClassName: 'responsive-header'

    items: [
      id: 'profile', label: T('My Profile')
    ,
      id: 'logout', label: T('Sign Out')
    ]

    initialize: ->
      @user = state.get('user')
      @options.label = @user.get('display_name') || 'User'
      @items.splice(1, 0, {id: 'account', label: T('My Account')}) unless config.private_chef
      super

    serialize: ->
      _.extend(super,
        { labelIcon: "user", username: @user.get('display_name') }
      )
