define (require) ->
  Backbone = require('b')
  template = require('j!clients/details')
  PublicKeyView = require('views/controls/public_key')
  Spinner = require('views/controls/spinner')
  $ = require('jquery')
  ClientDetails = require('models/client_details')
  ErrorAlertView = require('views/controls/alerts/error')

  class ClientDetailsView extends Backbone.Layout
    template: template
    initialize: ->
      @app = @options.app

    afterRender: ->
      @setView('.spinner', new Spinner).render()
      @detailsModel = new ClientDetails({organization_url: @app.currentOrg.url(), id: @model.id})
      @detailsModel.fetch()
        .success (data) =>
          @setView('.public-key', new PublicKeyView({ model: @detailsModel })).render()
        .fail (xhr) =>
          @setView('.public-key', new ErrorAlertView(body: "An error occured fetching the details of the client. Please try again later.")).render()
        .always () =>
          @$(".spinner").html("")
          @$(".public-key").css("display", "block")


