define ['backbone', 'backbone.layoutmanager', 'bootstrap-collapse' ], (Backbone, LayoutManager, bootstrapCollapse) ->
  class Accordion extends Backbone.Layout
    events:
      'click .accordion-toggle': 'clickHeading'

    initialize: (options) ->
      @multi ?= @options.multi ? false
      @sections = @options.sections ? []
      @parent = @options.parent ? true
      @allowNone = @options.allowNone ? true

    beforeRender: ->
      for section in @sections
        @insertView(section)

    # idempotent method that opens the accordion_section passed (element) and closes all others.
    # it will take no action if the currently opened element is the element passed
    openThisAndCloseAllOthers: (element, options) ->
      if @multi
        element.find(".collapse").collapse('toggle')
      else
        if not element.find(".accordion-toggle").hasClass("active")
          # only current element should be active
          @$(".active").removeClass("active")
          element.find(".accordion-toggle").addClass("active")

          # collapse all non-active elements that are open (that's what this complex jquery query does)
          @$(".in").parents(".accordion-group").find(".accordion-toggle").not(".active").parents(".accordion-group").find(".accordion-body").collapse("hide")

          # un-collapse active tab if its not already un-collapsed
          if not element.find(".collapse").hasClass("in")
            element.find(".collapse").collapse('show')

      @triggerSectionEvents(element, options)

    triggerSectionEvents: (element, options) ->
      section = element.data('section')
      if section and not options?.silent
        section.trigger('toggle')
        @trigger("toggle:#{section.name}")

    clickHeading: (evt) ->
      evt.preventDefault()
      @openThisAndCloseAllOthers($(evt.currentTarget).parents(".accordion-group"))
