define (require) ->
  Semimodal = require("views/controls/semimodal")
  Spinner = require("views/controls/spinner")
  tpl = require("j!controls/add_button")
  _ = require("underscore")
  T = require("utils/i18n.gettext")
  $ = require("jquery")

  class AddButton extends Semimodal
    template: tpl
    tagName: 'span' # Allow inline use
    events:
      'click .add-button': 'clickToggle'

    initialize: ->
      super
      @on('pullout', @attachPulloutEvents, @)
      @on('open', @resetInput, @)
      _.bindAll(@, 'clickOk', 'clickCancel')

    cleanup: ->
      @disableSpinner()
      super

    attachPulloutEvents: ->
      @$pullout.find('.add-ok').click(@clickOk).end().find('.add-cancel').click(@clickCancel)

    resetInput: ->
      @$pullout.find('input').val('').focus().end().find('.alert').remove()

    clickOk: (evt) ->
      $elm = $(evt.currentTarget)
      unless $elm.hasClass('disabled')
        input = @$pullout.find('input').val()
        @trigger('add', input)

    clickCancel: (evt) ->
      $elm = $(evt.currentTarget)
      unless $elm.hasClass('disabled')
        @close()

    enableSpinner: ->
      @spinner = true
      @$pullout.find('.add-ok').html('<i class="fa fa-spinner fa-spin"></i>').
        end().find('button').addClass('disabled')
      @

    disableSpinner: ->
      if @spinner
        @$pullout.find('.add-ok').html('<i class="fa fa-ok"></i>').end().
          find('button').removeClass('disabled')
        @spinner = false
        if @closePending
          @closePending = undefined
          @close()
      @

    error: (msg) ->
      msg ||= T('An error occurred, please try again.')
      $alert = @$pullout.find('.alert')
      if $alert.length
        $alert.text(msg)
      else
        $('<div class="alert alert-error"></div>').text(msg).appendTo(@$pullout)
      @closePending = undefined # Prevent queued closure
      @

    close: ->
      if @spinner
        @closePending = true
        @
      else
        super
