define (require) ->
  Backbone = require('b')
  AttributesModal = require('views/controls/modals/attributes')
  template = require('j!controls/attributes')
  _ = require('underscore')
  Empty = require('views/controls/empty')
  AttributesTreeView = require('views/controls/attributes/tree')

  class AttributesView extends Backbone.Layout
    className: 'attributes-view panel'

    @TreeView: AttributesTreeView
    treeViewClass: @TreeView
    template: template

    events:
      'click nav .expandall': 'expandAll'
      'click nav .collapseall': 'collapseAll'
      'click nav .edit': 'edit'

    initialize: (options) ->
      @objectType = options.objectType || 'Node'
      @app = @options.app
      @title = options.title || 'Attributes'

    serialize: ->
      {title: @title}

    cleanup: ->
      @model.off(null, null, @)

    modelAttributes: ->
      # For subclasses
      @model.get('attributes')

    beforeRender: ->
      @setRoots()
      @model.on("change:#{@rootString}", @render, @)
      if _.isEmpty(@root)
        view = new Empty()
        @tree =  null
        @setView('.content', view)
      else
        @tree = new @treeViewClass({root: @root})
        @setView('.content', @tree)

    expandAll: (evt) ->
      evt.preventDefault()
      @tree?.expandAll()

    collapseAll: (evt) ->
      evt.preventDefault()
      @tree?.collapseAll()

    edit: (evt) ->
      evt.preventDefault()
      new AttributesModal({
        model: @model
        app: @app
        root: @editRoot
        title: "Edit #{@objectType} Attributes"
        editAttribute: @options.rootAttribute
        action: @options.action
      })

    # Set values for the root attributes
    setRoots: ->
      @rootString = @options.rootAttribute || 'attributes'
      @root = @options.root || @model.get(@rootString)
      @editRoot = @options.editRoot || if @options.editRootAttribute
        @model.get(@options.editRootAttribute)
      else
        @root
