define (require) ->
  AttributesLeafNode   = require('views/controls/attributes/leaf_node')
  AttributesParentNode = require('views/controls/attributes/parent_node')
  TreeView             = require('views/controls/tree')
  _                    = require('underscore')

  class AttributesTreeView extends TreeView
    leafNodeClass: AttributesLeafNode
    parentNodeClass: AttributesParentNode

    initialize: ->
      @options.root = @convertAttributes(@options.root)
      super

    convertAttributes: (object) ->
      if _.isArray(object)
        for value, i in object
          {key: i, value: @convertAttributes(value)}
      else if _.isObject(object)
        for key, value of object
          {key: key, value: @convertAttributes(value)}
      else
        object

    children: (object) ->
      _.isArray(object.value) and object.value
