define (require) ->
  Backbone = require('b')
  constraintEditItemTpl = require('j!controls/constraints_editor/edit_item')

  class ConstraintEditItemView extends Backbone.Layout
    tagName: 'tr',

    template: constraintEditItemTpl

    events:
      'change': 'onConstraintChange',
      'click .remove-constraint': 'onRemoveClick'

    serialize: ->
      {constraint: @model.toJSON()}

    afterRender: ->
      @.$('[value="' + @model.get('operator') + '"]').prop('selected', true)

    onRemoveClick: (e) ->
      e.preventDefault()
      @model.destroy()

    onConstraintChange: (e) ->
      @model.set({
        operator: @$('.constraint-operator').val(),
        version: @$('.constraint-version').val()
      })
