define (require) ->
  Backbone = require('b')
  T        = require('utils/i18n.gettext')
  _        = require('underscore')

  require('jquery.layout')

  class Layout extends Backbone.Layout
    defaultOptions:
      defaults:
        # Run all the default tooltips through translation
        resizerTip: T('Resize')
        sliderTip: T('Slide Open')
        togglerTip_open: T('Close')
        togglerTip_closed: T('Open')
        togglerContent_closed: '▼'
        togglerContent_open: '▲'
        togglerLength_open: 100
        togglerLength_closed: 100

    initialize: ->
      @layoutOptions = @options.layoutOptions ? {}
      # Simple two-level default merge
      for key, value of @defaultOptions
        if _.isObject(value)
          @layoutOptions[key] = _.defaults(@layoutOptions[key] ? {}, value)
        else
          @layoutOptions[key] ?= value
      @layoutOptions.onresize = _.bind(@.onResize, @)
      @setViews(@options.xviews ? {})

    cleanup: ->
      if not @instance.destroyed
        @instance?.destroy()
      @instance = undefined

    afterRender: ->
      # Clean any existing one
      @instance?.destroy()
      # Stretch the container element to full size so we don't have to worry
      # about the stub div
      @instance = @$el.css({width:'100%',height:'100%'}).layout(@layoutOptions)

    onResize: (args...) ->
      @trigger('resize', args...)
