define (require) ->
  JSONEditor = require('views/controls/json_editor')
  Modal = require('views/controls/modals/base')
  _ = require('underscore')
  state = require('state')
  tpl = require('j!controls/modals/attributes')

  class AttributesModal extends Modal
    className: "#{@::className} modal-attributes"
    template: tpl
    events:
      'click .btn-primary': 'submit'

    initialize: ->
      @options.controller ||= state.get('controller')
      @attributesType = @options.editAttribute || 'normal'
      @root = @model.get(@attributesType)

      @attributesEditor = new JSONEditor({
        model: @model, attribute: @attributesType, autofocus: true
      })

      @setView('.attributes-editor', @attributesEditor)

      super

    serialize: ->
      _.extend(super, {
        @root,
        attributesType: @friendlyAttributesType(),
      })

    submit: (evt) ->
      evt.preventDefault()
      if @attributesEditor.submit()
        @queueAction(@options.action ? @attributesType, @model.get(@attributesType))
        @remove()

    friendlyAttributesType: ->
      @attributesType.replace(/_attributes/, '')
