define (require) ->
  Modal = require("views/controls/modals/base")
  tpl = require("j!controls/modals/confirmation")
  T = require("utils/i18n.gettext")

  class ConfirmationModal extends Modal
    className: "#{@::className} modal-confirmation"
    template: tpl
    yesButtonText: T('Proceed')

    events:
      'click .btn-yes': 'clickYes'
      'click [data-dismiss=modal]': 'clickNo'

    initialize: ->
      @options.title ?= T('Are you certain?')
      @options.message ?= T('Are you certain you want to continue?')
      @yesButtonText ?= @options.yesButtonText ? @::yesButtonText

      super
      @yesFn = @options.yes
      @noFn = @options.no

    serialize: ->
      _.extend(super, { yesButtonText: @yesButtonText })

    clickYes: (evt) ->
      evt.preventDefault()
      @yesFn() if @yesFn
      @remove()

    clickNo: (evt) ->
      evt.preventDefault()
      @noFn() if @noFn
