define (require) ->
  Modal         = require('views/controls/modals/base')
  RunListEditor = require('views/controls/run_list_editor')
  template      = require('j!controls/modals/edit_run_list')
  environmentCookbooks = require('collections/environments/cookbooks')

  class EditRunListModal extends Modal
    template: template
    events: 'click .btn-primary': 'submit'
    initialize: (options) ->
      @model = @collection.at(0)
      @environment = '_default'
      @organization = options.app.organizations.last()
      @runList = @model.get('run_list')
      @runListEditor = new RunListEditor(
        { @environment, @model, @organization }
      )
      environmentCookook = new environmentCookbooks([], { @environment, @organization })
      @cookbooksObject = environmentCookook.fetch({ reset: true })
      super()

    beforeRender: ->
      @setView('.modal-body', @runListEditor)

    getProcessedRunList: ->
      @model.get('run_list').map (item) ->
        if item.type != undefined
          "#{item.type}[#{item.name}]"

    appendRunlist: ->
      currentList = @model.get('run_list')
      if typeof currentList[0] != 'string'
        @queueAction('edit_run_list', @getProcessedRunList())
        $('.runlist .treeview').html ''
        @cookbooks = @cookbooksObject.responseJSON
        itr = 0
        while itr < currentList.length
          if typeof currentList[itr] != 'string'
            iconClass = if currentList[itr].type != 'recipe' then 'fa-th-large' else 'fa-book'
            position = '...'
            version = '...'
            if currentList[itr].type == 'recipe'
              cookbook = @cookbooks[currentList[itr].name]
              version = if cookbook != undefined then cookbook.versions[0].version else "..."

            $('.runlist .treeview').append '<li class="leaf"><span class="runlist-tree-version">' + version + '</span><span class="runlist-tree-position">' + position + '</span><i title="' + currentList[itr].type.charAt(0).toUpperCase() + currentList[itr].type.slice(1) + '" class="' + iconClass + '"></i><span class="runlist-tree-name ' + currentList[itr].type + '">' + currentList[itr].name + '</span></li>'
          ++itr

    submit: ->
      if @getProcessedRunList() != "" && @getProcessedRunList() != undefined
        @appendRunlist()
      @remove()
