define (require) ->
  Backbone = require('b')
  BaseModal = require('views/controls/modals/base')
  T = require('utils/i18n.gettext')
  _ = require('underscore')
  checkForBlobSupport = require('utils/blob_supported')
  saveAs = require('FileSaver')
  template = require('j!controls/modals/rekey')

  class RekeyModal extends BaseModal
    className: "#{@::className} modal-rekey"
    template: template
    events:
      'click .btn-reset': 'rekey'
      'click .btn-download': 'download'

    initialize: (@options) ->
      @state = new Backbone.Model({ closeButtonText: @closeButtonText })
      super()

      @state.on('change', @render, @)
      @model.on('request', => @state.set({ state: 'started' }))

      checkForBlobSupport.then (onFulfilled, onRejected) =>
        @state.set({ blobSupported: onFulfilled || onRejected })

    serialize: ->
      _.extend(
        super(),
        {
          blobSupported: @state.get('blobSupported')
          closeButtonText: @state.get('closeButtonText')
          message: @state.get('message')
          privateKey: @model.get('private_key')
          state: @state.get('state')
        }
      )

    rekey: (evt) ->
      evt.preventDefault()

      @model.rekey().then (data) =>
        @model.set(data)
        @state.set({ state: 'finished' })
      .fail (xhr) =>
        @state.set({
          message: xhr.responseJSON?.error or xhr.statusText
          state: 'error'
        })
      .always =>
        @state.set({ closeButtonText: T('Close') })

    download: (evt) ->
      evt.preventDefault()
      if @model.get('private_key') && @state.get('blobSupported')
        saveAs(new Blob([@model.get('private_key')]), "#{@model.id}.pem")
