define (require)->
  Modal = require('views/controls/modals/base')
  _ = require('underscore')
  config = require('config')
  i18n = require('utils/i18n')
  state = require('state')

  class ReportFeedback extends Modal
    template: require('j!controls/modals/report_feedback')
    title: i18n.gettext('Feedback')
    className: "#{@::className} modal-feedback"
    events:
      'click .btn-primary': 'submit'

    beforeRender: ->
      super()
      @closeButtonText = if @app.isHosted() then 'Cancel' else 'Close'

    serialize: ->
      _.extend( super(),
                hosted: @app.isHosted()
                support_email_address: config.support_email_address )

    submit: (evt) ->
      evt.preventDefault()
      subject = @$('.subject input').val()
      description = @$('.description textarea').val()
      if subject.length == 0 or description.length == 0
        @$("#validation-error-message").show()
      else
        @$("#validation-error-message").hide()
        @queueAction('util/report_feedback', subject, description, @getBrowserInfo(), @getAppState())
        @remove()

    getBrowserInfo: ->
      browser: jQuery.browser
      navigator: _.omit(window.navigator, 'plugins', 'mimeTypes')
      window_innerHeight: window.innerHeight
      window_innerWidth: window.innerWidth

    getAppState: ->
      _.extend _.pick(config.user, "first_name", "last_name", "email"),
        url: window.location.href
        activeController: state.get('controller')?.collection_type
        selection: (model.id for model in @app.selection.models)
        collectionCount: @controller.collection.length
        user: state.get('user')?.id
        org: @app.mainnav.currentOrg.id
