define (require) ->
  Modal = require('views/controls/modals/base')
  template = require('j!controls/modals/run_details')
  T = require('utils/i18n.gettext')
  _ = require('underscore')
  Empty = require('views/controls/empty')

  class RunDetailsModal extends Modal
    className: "#{@::className} modal-run-details"
    template: template
    events:
      'click .btn-close': 'clickClose'
      'mouseover .sub-entry-column': 'handleMouseOver'
      'mouseout .sub-entry-column': 'handleMouseOut'

    initialize: ->
      @options.title ?= T('Resource Parameters')
      @options.message ?= T('The object you were viewing was deleted')

      # The keys are the names of the properties being displayed. Merge the
      # keys from the initial_state and final_state for a complete list
      @keys = Object.keys(_.extend(
        {},
        @options.run_step.get("initial_state"),
        @options.run_step.get("final_state")
      ))

      super

    serialize: ->
      _.extend({keys: @keys, run_step: @options.run_step}, super)

    afterRender: ->
      super()
      if @keys.length == 0
        @setView(".modal-body", new Empty).render()

    clickClose: (evt) ->
      evt.preventDefault()
      @trigger("modalCloseEvent")
      @remove()

    handleMouseOver: (e) ->
      @$(e.target).parent().eq(0).addClass("highlighted")

    handleMouseOut: (e) ->
      @$(e.target).parent().eq(0).removeClass("highlighted")
