define (require) ->
  $ = require('jquery')
  Backbone = require('b')
  template = require('j!controls/modals/wizard/breadcrumbs')

  class WizardBreadcrumbs extends Backbone.Layout
    className: 'breadcrumb'
    tagName: 'ul'
    template: template

    events:
      'click li a': 'navigate'

    initialize: (options) ->
      { @wizard } = options
      @render()

    serialize: ->
      { steps: @steps() }

    navigate: (event) ->
      event.preventDefault()
      @wizard.goToStep($(event.currentTarget).parent().index())

    steps: ->
      $.map @wizard.steps, (step, index) =>
        title = $(step).data('title')
        active = if index == @wizard.currentStepIndex then 'active' else ''
        { title, active }
