define (require) ->
  $        = require('jquery')
  Backbone = require('b')

  class WizardNavigationButtons extends Backbone.Layout
    className: 'btn-group'

    initialize: (options) ->
      { @wizard } = options

      @nextButton = $('<button />', {
        class: 'btn-next btn'
        html: '&nbsp;&nbsp;Next&nbsp;&nbsp; <i class="fa fa-chevron-right"></i>'
        disabled: true
      })
      @previousButton = $('<button />', {
        class: 'btn-previous btn'
        html: '<i class="fa fa-chevron-left"></i> Previous'
        disabled: true
      })

      @previousButton.on 'click', => @wizard.goToPreviousStep()
      @nextButton.on 'click', => @wizard.goToNextStep()

    afterRender: ->
      @previousButton.prop('disabled', @wizard.isFirstStep())
      @nextButton.prop('disabled', @wizard.isLastStep())
      @$el.empty().append(@previousButton, @nextButton)
