define (require) ->
  Backbone = require('b')
  template = require('j!controls/notification_center')
  OrgInvitationModal = require('views/application/modals/org_invitation')
  MasterQueueErrorsModal = require('views/application/modals/master_queue_errors_modal')

  class NotificationCenter extends Backbone.Layout
    template: template
    events:
      "click .total_invites":"renderOrgInvitesModal"
      "click .errors_pending":"renderErrorsModal"

    initialize: (options) ->
      @app = options.app
      @usernav = options.usernav
      @totalInvites = options.totalInvites
      # an instance of JobQueue
      @errorQueue = options.errorQueue

    serialize: ->
      {totalInvites: @totalInvites, errorArrayLength: @errorQueue.length()}

    updateNotifications: (totalInvites) ->
      @totalInvites = totalInvites
      # picks up new errorArrayLength from @errorQueue object automatically
      @render()

    hide: ->
      @$(".notification_center").hide()

    toggle: ->
      @$(".notification_center").toggle()

    renderOrgInvitesModal: (evt) ->
      evt.preventDefault()
      new OrgInvitationModal({app: @app, usernav: @usernav, title: "Organization Invitations"})

    renderErrorsModal: (evt) ->
      evt.preventDefault()
      new MasterQueueErrorsModal({app: @app, errorQueue: @errorQueue, title: "Errors from Background Processes"})
