define (require) ->
  tpl = require("j!controls/queue_view")
  SuccessLine = require("views/controls/alerts/success_line")
  ErrorLine = require("views/controls/alerts/error_line")
  Backbone = require("b")
  $ = require("jquery")

  class QueueView extends Backbone.Layout
    template: tpl
    initialize: ->
      @jobQueue = @options.jobQueue
      @masterQueue = if @options.masterQueue? then @options.masterQueue else null
      @originalSize = @jobQueue.length()
      @totalErrors = 0

      @jobQueue.on("success", @setCurrentProgress, @)
      @jobQueue.on("error", @setCurrentProgress, @)
      @jobQueue.on("error", @displayError, @)
      @jobQueue.on("all_requests_sent", @setCurrentProgress, @)

    serialize: ->
      {requestArray: @requestArray}

    cleanup: ->
      if @masterQueue?
        @jobQueue.sendRemainingToDifferentQueue(@masterQueue)

    setCurrentProgress: ->
      percentageString = "#{((@originalSize - @jobQueue.length()) / @originalSize)*100}%"
      @$(".progress_bar").animate(width: percentageString, 50)
      @$(".total_processed").html("Sent #{@numberRequestsProcessed()} of #{@originalSize} requests.")
    allRequestsFinished: ->
      if @totalErrors > 0
        @setView(".status", new ErrorLine({body: "All #{@originalSize} requests finished with #{@totalErrors} errors."})).render()
      else
        @setView(".status", new SuccessLine({body: "All #{@originalSize} requests finished!"})).render()

    numberRequestsProcessed: ->
      @originalSize - @jobQueue.length()

    displayError: (xhr, status, error, model) ->
      @totalErrors += 1
      id = if model?.id?
        model.id
      else
        "request-#{@numberRequestsProcessed()}"
      newDiv = document.createElement('div')
      generatedClassName = "queue_view-#{id}"
      newDiv.className = generatedClassName
      if xhr.status == 403
        @$(".error").append(newDiv)
        @setView(".#{generatedClassName}", new ErrorLine({body:"You did not have permission to perform requested action on #{id}!"})).render()
      else
        @$(".error").append(newDiv)
        @setView(".#{generatedClassName}", new ErrorLine({body:"Request for #{id} failed! Please try again."})).render()
