define (require) ->
  AvailableRecipesView = require('views/controls/run_list_editor/available_recipes')
  AvailableRolesView   = require('views/controls/run_list_editor/available_roles')
  Backbone             = require('b')
  CurrentView          = require('views/controls/run_list_editor/current')
  Recipes              = require('collections/recipes')
  Roles                = require('collections/roles')
  template             = require('j!controls/run_list_editor')
  normalizeRunList     = require('views/controls/run_list_editor/helpers/normalize_run_list')
  $                    = require('jquery')

  class RunListEditor extends Backbone.Layout
    _.extend(@::, normalizeRunList)

    template: template

    initialize: (options) ->
      # create deep copy of starting run list so we don't permute the model!
      @startingRunList = []
      for item in @normalizeRunList(@model.get("run_list"))
        @startingRunList.push($.extend(true, {}, item))

      # if the current model is a role, also exclude from available roles
      if @model.get("chef_type") == "role"
        @startingRunList.push({name: @model.get('name'), type: "role"})

      { @environment, @organization, @currentRole } = options
      @recipes = new Recipes([], { @environment, @organization })
      @roles = new Roles([], { @organization })

      @setView('.recipes', new AvailableRecipesView({
        collection: @recipes
        containment: @el
        connectWith: '.current ul'
        startingRunList: @startingRunList
        filterable: true
      }))
      # roles is not filterable since it has infinite scrolling
      @setView('.roles', new AvailableRolesView({
        collection: @roles
        containment: @el
        connectWith: '.current ul'
        startingRunList: @startingRunList
        filterable: false
      }))
      @setView('.current', new CurrentView({
        model: @model
        containment: @el
        connectWith: '.available ul'
        environment: @environment
      }))


