define (require) ->
  $         = require('jquery')
  _         = require('underscore')
  Backbone  = require('backbone')
  draggable = require('views/controls/run_list_editor/helpers/draggable')
  template  = require('j!controls/run_list_editor/current')
  normalizeRunList = require('views/controls/run_list_editor/helpers/normalize_run_list')

  class CurrentView extends Backbone.Layout
    _.extend(@::, draggable)
    _.extend(@::, normalizeRunList)

    template: template

    initialize: (options) ->
      { @containment, @connectWith, @environment } = options
      @runList = @normalizeRunList(@model.get('run_list'))

    serialize: -> { @runList }

    afterRender: ->
      @draggableSetup({append: true})
      @draggable.on('sortstop sortreceive sortremove', @updateRunList)

    getParsedRunList: ->
      _.map @$('li:not(.ui-sortable-placeholder)').toArray(), (li) ->
        li = $(li); name = li.text(); type = li.data('type')
        { name, type }

    updateRunList: =>
      runList = @getParsedRunList()
      @model.set({ run_list: runList})
      @model.run_lists().get(@environment)?.set({ run_list: runList })
