# Mixin for views that load more content by scrolling
define (require) ->
  scroll: (event) ->
    event.preventDefault()
    @waitingForScrollResponse ?= false

    # if scrollTop is within lower 30% fetch more.
    threshold = event.target.offsetHeight + (event.target.offsetHeight * 0.30)

    if (event.target.scrollHeight - event.target.scrollTop) < threshold and not @waitingForScrollResponse and not @reachedBottom?
      @collection.requestNextPage({
        update: true,
        remove: false,
        success: (collection, response) =>
          # last response contained < page size, so we have reached bottom
          if response.results.length < collection.perPage
            @reachedBottom = true
          @waitingForScrollResponse = false
          @spinnerView.remove()
      })
      @setView('.spinner', @spinnerView).render()
      @waitingForScrollResponse = true
