define (require) ->
  Grid = require("views/controls/grid")

  class ScrollGrid extends Grid
    initialize: ->
      super
      @reachedEnd = false
      _.bindAll(@, 'viewportChanged')

    cleanup: ->
      super
      @instance?.onViewportChanged.unsubscribe(@viewportChanged)

    doGridInit: ->
      @setupScrolling()

    resize: ->
      super
      # In case we now need to load more
      @viewportChanged() if @instance

    setupScrolling: ->
      @instance.onViewportChanged.subscribe(@viewportChanged)
      @viewportChanged()

    viewportChanged: ->
      vp = @instance.getViewport()
      if @collection.length and (vp.bottom >= @collection.length) and not @collection.reachedEnd and @collection.queryStatus?.resting
        @collection.requestNextPage({
          update: true,
          remove: false,
          success: (collection, response) =>
            if response.results.length < @collection.paginator_ui.perPage
              @collection.reachedEnd = true
            # Check if we need to load another page. On a timeout to not
            # overwhelm the server.
            setTimeout((=> @viewportChanged()), 100)
        })
      @updateSpinners()

    updateSpinners: ->
      # Check for new spinners
      for model, i in @collection.models
        if model.get('isSpinner') and cell = @instance.getCellNode(i, 0)
          @$(cell).html("<i class='fa fa-spinner fa-spin loading-spinner'></i>")

    resetState: ->
      @reachedEnd = false
