define ['b', 'views/controls/dropdown', 'j!controls/select_dropdown', 'underscore', 'utils/i18n.gettext']
      ,(Backbone, Dropdown, tpl, _, T) ->
  class SelectDropdown extends Dropdown
    pulloutClassName: 'with-icons'
    template: tpl

    initialize: ->
      super
      @selected = @options.selected ? @items[0]?.id
      @on('action', @selectItem, @)

    beforeRender: ->
      @label = if @selected
        item = _.find(@items, (item) => item.id == @selected)
        item?.label ? @selected
      else
        T('Please select one')

    serialize: ->
      _.extend(super, {selected: @selected})

    selectItem: (action) ->
      @selected = action
      # There should probably one day be an option to disable the re-render if it will happen elsewhere anyway
      @cleanup()
      @render()
