define (reqiure) ->
  Backbone = require('b')
  _ = require('underscore')
  template = require('j!controls/tabs')

  class Tabs extends Backbone.Layout
    template: template

    initialize: (@options = {}) ->
      @tabs = @options.tabs ? []
      @currentTabId = @options.currentTabId ? @tabs[0]?.id

    beforeRender: (render) ->
      if currentTab = @getTab(@currentTabId)
        @currentView = this.tabView(currentTab)
        @setView('.tab-content', @currentView)

    serialize: ->
      currentTabId: @currentTabId
      queryParams: @queryParams()
      tabs: @tabs
      urlBase: @urlBase()

    events:
      'click ul.nav li': 'changeTab'

    changeTab: (evt) ->
      evt.preventDefault()
      elm = $(evt.target).parents('li')
      @currentTabId = elm.data('tab')
      @render()

    getTab: (id) ->
      _.findWhere(@tabs, {id: id})

    # The query parameters given in the options, or as part of the given
    # urlBase
    queryParams: ->
      q = @options.queryParams ? (@options.urlBase ? '').split('?')[1] ? ''
      if q && q.indexOf('?') == -1
        "?#{q}"
      else
        q

    tabView: (tab) ->
      tab.view

    # The value given in the options for urlBase not including any query
    # parameters
    urlBase: ->
      (@options.urlBase ? '').split('?')[0]
