define (require) ->
  TreeNode = require('views/controls/tree/node')
  template = require('j!controls/tree/parent_node')

  class TreeParentNode extends TreeNode
    template: template
    childrenRendered: false
    className: 'parent'
    events: ->
      'click .treeview-toggle': 'toggle'

    initialize: ->
      super

    toggle: (evt) ->
      evt.preventDefault()
      evt.stopPropagation() # This might not be needed

      # on first toggle, we want to render the children for lazy rendering
      if not @childrenRendered
        @renderChildren()

      @$el.children('.treeview-children').toggle()
      @$('> .treeview-toggle .treeview-toggle-icon').toggleClass('fa-plus fa-minus')

    renderChildren: ->
      @childrenRendered = true
      # if we haven't rendered the childrenNodes yet
      @childrenNodes = for object in @collection
        @tree.node(object)
      @insertViews({'> .treeview-children': @childrenNodes})
      @render()

      # if we want to recursively load all the subtree
      if @tree.renderChildrenRecursively
        for child in @childrenNodes
          if child.className == 'parent'
            child.renderChildren()
