define (require) ->
  Backbone = require('b')
  markdown = require('utils/markdown')
  router = require('router')
  template = require('j!cookbooks/details')

  class CookbookDetailsView extends Backbone.Layout
    template: template

    events:
      'click .versions li': 'changeVersion'

    initialize: (@options = {}) ->
      # The @model is a Cookbook model, which holds the list of versions, the
      # name of the cookbook, and the currently displyed version.
      #
      # A Cookbook has many CookbookVersions, one of which we use here. This
      # model contains all of the other data about a Cookbook's current version.
      if typeof @model?.displayVersionModel == 'function'
        @cookbookVersion = @model.displayVersionModel()
        @listenTo(@cookbookVersion, 'change', @render)

    serialize: ->
      metadata = @cookbookVersion?.get('metadata') ? {}

      {
        displayVersion: @model?.get('displayVersion')
        license: metadata.license ? ''
        longDescription: metadata.long_description
        platforms: metadata.platforms ? []
        markdown: markdown
        versions: @model?.get('versions') ? []
      }

    changeVersion: (event) ->
      newVersion = event.currentTarget.getAttribute('data-version')
      router.navigate("#{@model.url()}/#{newVersion}", { trigger: true })
