define (require) ->
  List = require('views/controls/list')
  T = require('utils/i18n.gettext')
  router = require('router')

  class CookbooksList extends List
    actionColumn: false
    columns: [
      {
        id: "name",
        name: T("Cookbook"),
        field: -> @id
      },
      {
        id: "current_version",
        name: T("Current Version"),
        field: -> @get('current_version')
      },
    ]

    # When we're viewing a single cookbook, the preload logic in Rails sets the
    # currentPage of the collection to -1 as a signal to paginated collections
    # that they need to be fetched. We use that signal in this non-paginated
    # collection to do the same thing.
    beforeRender: ->
      super()
      if @collection.currentPage == -1
        @collection.fetch()
        delete @collection.currentPage

    updateSelection: ->
      if @selection.length <= 1
        @$el.removeClass('list-multiselect')

        if @selection.length == 1
          router.navigate(@selection.at(0).currentVersionUrl(),
            { trigger: true })
        else
          router.navigate(@collection.url(), { trigger: true })
      else
        @$el.addClass('list-multiselect')
