define (require) ->
  AttributesView  = require('views/controls/attributes')
  Backbone        = require('b')
  DeleteItemModal = require('views/databag_items/modals/delete')
  EditItemModal   = require('views/databag_items/modals/edit')
  template        = require('j!databag_items/details')

  class DataBagItemView extends Backbone.Layout
    className: 'panel'

    template: template

    events:
      'click .delete-item': 'onDeleteItemClick'
      'click .edit-item': 'onEditItemClick'
      'click .collapse-all': 'onCollapseAllClick'
      'click .expand-all': 'onExpandAllClick'

    initialize: (options) ->
      @app = options.app
      @model.on('change', @render, @)
      @model.on('destroy', @remove, @)

    serialize: -> { @model }

    afterRender: ->
      @tree = new AttributesView.TreeView({root: @model.get('data')})
      @setView('.databag-item-data', @tree).render()

    onDeleteItemClick: (e) ->
      e.preventDefault()
      new DeleteItemModal({
        model: @model,
        app: @app
      })

    onEditItemClick: (e) ->
      e.preventDefault()
      new EditItemModal({
        model: @model
        app: @app
      })

    onCollapseAllClick: (e) ->
      e.preventDefault()
      @tree.collapseAll()

    onExpandAllClick: (e) ->
      e.preventDefault()
      @tree.expandAll()
