define (require) ->
  Modal         = require('views/controls/modals/base')
  JSONEditor    = require('views/controls/json_editor')
  template      = require('j!databag_items/modals/edit')

  class EditItemModal extends Modal
    template: template
    events: 'click .btn-primary': 'submit'

    initialize: (options) ->
      @model = options.model
      @dataEditor = new JSONEditor({
        attribute: 'data',
        model: @model
      })
      super()

    beforeRender: ->
      @setView('.modal-body', @dataEditor)

    submit: ->
      if @dataEditor.submit()
        @model.sync('update', @model, {
          url: @model.url()
          success: (data, textStatus, jqXHR) => @remove()
        })
