define (require) ->
  BaseModal = require('views/controls/modals/base')
  ConstraintsEditorView = require('views/controls/constraints_editor')
  Cookbooks = require('collections/cookbooks')
  ErrorLineView = require('views/controls/alerts/error_line')
  Spinner = require('views/controls/spinner')
  T = require('utils/i18n.gettext')
  template = require('j!environments/modals/cookbook_constraints')

  class CookbookConstraintsModal extends BaseModal
    template: template
    title: T('Edit Cookbook Constraints')

    cleanup: ->
      super
      @constraintView.off(null, null, @)

    events:
      'click .btn-submit': 'submit'

    afterRender: ->
      super()
      cookbooks = new Cookbooks([], { organization: @options.org })
      cookbooks.fetch({ reset: true })

      @constraintView = new ConstraintsEditorView({
        constraints: @model.constraints
        cookbooks: cookbooks
      })
      @setView('.constraints', @constraintView).render()

      @constraintView.on("no_cookbook_error", @noCookbooksAvaliable, @)

    noCookbooksAvaliable: ->
      @$(".btn-primary").remove()
      @$(".btn-close").html("Close")

    submit: ->
      @setView('.message', new Spinner).render()
      @model.save(@model.attributes, {
        success: @remove.bind(@)
        error: (model, xhr) =>
          @setView('.message', new ErrorLineView({
            body: xhr?.responseJSON?.error
          })).render()
        validate: false
      })
