define (require) ->
  ConstraintsEditorView = require('views/controls/constraints_editor')
  T = require('utils/i18n.gettext')
  JsonWizard = require('views/controls/modals/json_wizard')
  template = require('j!environments/modals/create')

  class CreateEnvironmentWizard extends JsonWizard
    template: template
    title: T('Create Environment')

    initialize: ->
      @app = @options.app
      @cookbooks = @options.cookbooks
      super()
      @model.collection = @app?.currentOrg?.environments

    beforeRender: ->
      super()
      @setView('.constraints', new ConstraintsEditorView({
        constraints: @model.constraints,
        cookbooks: @cookbooks
      }))

    afterRender: ->
      @cookbooks.fetch({reset: true})
      super()

    onSaveError: (jqXHR, textStatus, errorThrown) =>
      @errorMessage = jqXHR?.responseJSON?.error || 'Internal Server Error'
      @saveFailed = true
      @closeButtonText = T('Close')
      @render()
      # Hide additional wizard elements
      @$('.modal-subheader, nav.wizard').hide()

