define (require) ->
  ListView = require('views/controls/list')
  T = require('utils/i18n.gettext')

  class GroupListView extends ListView
    columns: [
      {
        id: "groupname",
        name: T("Group Name"),
        field: -> @id
      },
    ]

    # When we're viewing a single group, the preload logic in Rails sets the
    # currentPage of the collection to -1 as a signal to paginated collections
    # that they need to be fetched. We use that signal in this non-paginated
    # collection to do the same thing.
    beforeRender: ->
      super()
      if @collection.currentPage == -1
        @collection.fetch()
        delete @collection.currentPage
