define (require) ->
  MembersList = require('views/controls/members/list')
  GroupMembersGrid = require('views/groups/members/grid')
  T = require('utils/i18n.gettext')

  class GroupMembersList extends MembersList
    headerHeight: 133
    gridClass: GroupMembersGrid
    columns: [
      {
        id: "name",
        name: T("Name"),
        field: "name"
      },
      {
        id: "type",
        name: T("Type"),
        field: "type"
      },
      {
        id: "remove",
        name: T("Remove"),
        width: 70,
        resizable: false,
        formatter: (row, cell, value, columnDef, dataContext) ->
          type = dataContext.get('type')
          name = dataContext.get('name')
          """<button class="btn btn-mini remove-member" type="button" data-type="#{type}" data-name="#{name}">#{T("Remove")}</button>"""
      },
    ]

    onResize: ->
      super
      @grid.resize()
