define (require) ->
  Group    = require('models/group')
  Modal    = require('views/controls/modals/base')
  T        = require('utils/i18n.gettext')
  template = require('j!groups/modals/create')

  class CreateGroupModal extends Modal
    title: T('Create Group')
    template: template

    bindings:
      '[name=name]': 'groupname'

    events:
      'click .btn-submit': 'submit'

    initialize: (options) ->
      @model = new Group({}, { collection: @options.app.currentOrg.groups })

      super()

      @model.on('validated', @toggleSubmit)

    serialize: ->
      _.extend(super(), { @state })

    afterRender: ->
      @submitButton = @$('.btn-submit')
      @bindValidation()
      super()

    submit: (event) ->
      event.preventDefault()
      return if @state and @state != 'error'
      @model.validate().then =>
        @state = 'started'
        @render()
        @model.sync('create', @model, {
          url: @model.collection.url()
          success: (data, textStatus, jqXHR) => @onSaved()
          error: (jqXHR, textStatus, errorThrown) => @state = 'error'; @render()
        })

    # Enable or disable the create button based on the validity
    toggleSubmit: (model, result, isValid) =>
      @submitButton.prop('disabled', !isValid || @state == 'started')
