define (require) ->
  Backbone        = require('b')
  NodeSummaryView = require('views/nodes/summary')
  NodeTagsView    = require('views/nodes/node_tags')
  RunListView     = require('views/controls/run_list')
  template        = require('j!nodes/details')

  class NodeDetailsView extends Backbone.Layout
    template: template

    initialize: ->
      @app = @options.app

      @setViews({
        '.summary': new NodeSummaryView({ model: @model, app: @app })
        '.tags': new NodeTagsView({ model: @model, app: @app })
        '.runlist': new RunListView({
          collection: @model.run_lists()
          app: @app
        })
      })
