define (require) ->
  ListView = require('views/controls/list')
  NodeListHeaderView = require('views/nodes/list_header')
  T = require('utils/i18n.gettext')
  moment = require('moment')

  class NodeListView extends ListView
    headerClass: NodeListHeaderView
    columns: [
      {
        id: "name",
        name: T("Node Name"),
        field: -> @id
      },
      {
        id: "platform",
        name: T("Platform"),
        field: -> @get('attributes').platform
      },
      {
        id: "fqdn",
        name: T("FQDN"),
        field: -> @get('attributes').fqdn
      },
      {
        id: "ipaddress",
        name: T("IP Address"),
        field: -> @get('attributes').ipaddress
      },
      {
        id: "uptime",
        name: T("Uptime"),
        field: -> @get('attributes').uptime_seconds ? 0,
        formatter: (row, cell, value, columnDef, dataContext) ->
                label = if value == 0 then 'Unknown' else moment.duration(value, 'seconds').humanize()
                """<span title="#{value}">#{label}</span>"""
      },
      {
        id: "ohai_time",
        name: T("Last Check-In"),
        field: -> @get('attributes').ohai_time ? 0,
        formatter: (row, cell, value, columnDef, dataContext) ->
                label = if value == 0 then 'Never' else moment.unix(value).fromNow()
                """<span title="#{value}">#{label}</span>"""
      },
      {
        id: "environment",
        name: T("Environment"),
        field: 'chef_environment'
      },
    ]
