define (require) ->
  MembersTab = require('views/controls/members/tab')
  T = require('utils/i18n.gettext')

  class OrganizationMembersList extends MembersTab.List
    headerHeight: 145
    gridOptions:
      permissionsTooltipMessage: "You do not have permissions to remove this member from the currently selected organization"
    columns: [
      {
        id: "username",
        name: T("Name"),
        field: "username"
        # In the case that the user doesn't have permissions to view a user, the
        # id field is used so it doesn't show up blank.
        formatter: (row, cell, value, columnDef, dataContext) -> dataContext.id
      },
      {
        id: "remove",
        name: T("Remove"),
        width: 70,
        resizable: false,
        formatter: (row, cell, value, columnDef, dataContext) ->
          """<button class="btn btn-mini remove-member"data-id=#{dataContext.id} type="button">#{T("Remove")}</button>"""
      },
    ]
