define (require) ->
  LeaveOrganizationModal = require('views/organizations/modals/leave')
  MembersTab = require('views/controls/members/tab')
  OrganizationMembersList = require('views/organizations/members/list')
  RemoveUserModal = require('views/users/modals/remove_user_modal')
  Users = require('collections/users')
  state = require('state')
  template = require('j!organizations/members/tab')

  class OrganizationMembersTab extends MembersTab
    template: template
    collectionClass: Users
    listClass: OrganizationMembersList

    events:
      'click .remove-member': 'removeUser'
      'keyup input.filter': 'updateFilter'

    initialize: ->
      @app = @options.app

      # source of truth
      @originalCollection = new @collectionClass([], {organization: @model})
      @originalCollection.fetch()

      # collection we permute for search
      @collection = new @collectionClass([], {organization: @model})
      @collection.fetch()

      super

    applyFilter: (value) ->
      filter = new RegExp("^#{value}", "i")
      allMembers = @originalCollection.getThinSlickBackCollection()
      filteredMembers = allMembers.filter (item) ->
        item.get('id').match(filter)

      @collection.reset(filteredMembers)

    removeUser: (evt) ->
      evt.preventDefault()
      id = evt.currentTarget.getAttribute("data-id")
      @deleteModel = @originalCollection.get(id)
      if state.get('user')?.id == @deleteModel.id
        new LeaveOrganizationModal({
          app: @app
          controller: @
          model: @model
        })
      else
        modal = new RemoveUserModal({
          app: @app
          controller: @
          model: @model
          user: @deleteModel
        })
        modal.once('remove-success', @removed, @)

    removed: ->
      @originalCollection.remove(@deleteModel)
      @collection.remove(@deleteModel)
      delete @deleteModel
