define (require) ->
  Organization = require('models/organization')
  Modal = require('views/controls/modals/base')
  template = require('j!organizations/modals/create')

  class CreateOrganizationModal extends Modal
    title: 'Create Organization'

    template: template

    bindings:
      '[name="shortname"]': 'name'
      '[name="fullname"]': 'full_name'

    events:
      'click .btn-submit': 'submit'

    initialize: (options) ->
      @model = new Organization
      super()
      @model.collection = @app.organizations
      @model.on('validated', @toggleSubmit)

    serialize: ->
      _.extend(super(), { @state })

    afterRender: ->
      @submitButton = @$('.btn-submit')
      @bindValidation()
      super()

    submit: (event) ->
      event.preventDefault()
      return if @state and @state != 'error'
      @model.validate().then =>
        @state = 'started'
        @render()
        @model.sync('create', @model, {
          url: @model.collection.url()
          success: @onSaved
          error: @onError
        })

    onError: =>
      @state = 'error'
      @render()

    # Enable or disable the create button based on the validity
    toggleSubmit: (model, result, isValid) =>
      @submitButton.prop('disabled', !isValid || @state == 'started')
