define (require)->
  Backbone = require('b')
  ConfirmationModal = require('views/controls/modals/confirmation')
  T = require('utils/i18n.gettext')
  config = require('config')
  state = require('state')

  class StarterKitView extends Backbone.Layout
    template: require('j!organizations/starter_kit')

    events:
      'click button': 'downloadStarterKit'

    serialize: ->
      chef_documentation_url: config.chef_documentation_url
      chef_mailing_list_subscribe_url: config.chef_mailing_list_subscribe_url
      chef_supermarket_url: config.chef_supermarket_url
      chef_www_url: config.chef_www_url
      chef_title: config.chef_title
      csrf_param: @options?.app?.csrf_param
      csrf_token: @options?.app?.csrf_token
      learn_chef_url: config.learn_chef_url
      starter_kit_path: @options?.app?.currentOrg?.url() + '/getting_started'
      support_tickets_url: config.support_tickets_url
      username: state.get('user')?.id

    downloadStarterKit: (evt) ->
      evt.preventDefault()
      new ConfirmationModal({
        app: @options.app, controller: @,
        title: T('Are you certain?')
        message: T('Your user key will be reset. Are you sure you want to do this?'),
        yes: => @$('form').submit()
      })
