define (require) ->
  BaseModal = require('views/controls/modals/base')
  _ = require('underscore')
  tpl = require('j!reporting/runs/diff')

  class DiffModal extends BaseModal
    initialize: ->
      super
      @diff = @options.diff
    template: tpl
    events:
      'click .btn-close': 'close'

    close: ->
      @trigger("modalCloseEvent")
      @remove()

    afterRender: ->
      super
      $(".modal").addClass("diff-modal")
      table = @formatDiff(@diff)
      @$("#diff-parent").append(table)

    cleanup: ->
      @$(".modal").removeClass("diff-modal")
      super

    formatDiff: (diff_content) ->
      diff_content = "<pre>" + _.escape(diff_content) + "</pre>"
      diff_content = diff_content.split("\\n").join("</pre><pre>")

      # get parent element holding the diff content
      parent = $(document.createElement('div'))

      temp_div = $(document.createElement('div'))
      temp_div.html(diff_content)

      curr_addition_line_num = null
      curr_subtraction_line_num = null

      table = $(document.createElement('table'))
      table.toggleClass("diff_table")

      temp_div.children("pre").each( (index, element) ->
        first_three_char =  $(element).html().substring(0,3)
        new_html_string = null
        # exclude the first two lines of unified diff format
        if ( first_three_char != "---" and first_three_char != "+++" )
          first_two_char = $(element).html().substring(0,2)
          tr = $(document.createElement('tr'))
          tr.toggleClass("diff_row")

          subtract_td = $(document.createElement('td'))
          subtract_td.toggleClass("diff_number")

          addition_td = $(document.createElement('td'))
          addition_td.toggleClass("diff_number")

          if ( first_two_char == "@@" )
            re = /\@\@ -(\d+)[,\d+]* \+(\d+)[,\d+]*/
            regex_arr = $(element).html().match(re)
            if regex_arr?
              curr_addition_line_num = regex_arr[2]-1
              curr_subtraction_line_num = regex_arr[1]-1
            toggleClass = "diff_header"
            subtract_td.html("....")
            addition_td.html("....")
      
            curr_html_string = $(element).html()
    
          else if ($(element).html()[0] == "+")
            curr_addition_line_num++
            toggleClass = "diff_addition"
            subtract_td.html("")
            addition_td.html(curr_addition_line_num)
            curr_html_string = $(element).html()
  
          else if ($(element).html()[0] == "-")
            curr_subtraction_line_num++
            toggleClass = "diff_subtraction"
            subtract_td.html(curr_subtraction_line_num)
            addition_td.html("")
            curr_html_string = $(element).html()

          else
            curr_addition_line_num++
            curr_subtraction_line_num++
            subtract_td.html(curr_subtraction_line_num)
            addition_td.html(curr_addition_line_num)
            toggleClass = "diff_normal"
            curr_html_string = $(element).html()

          line_td = $(document.createElement('td'))
          line_pre = $(document.createElement('pre'))
          line_pre.html(curr_html_string)
          line_td.append(line_pre)
          line_td.toggleClass(toggleClass)
          tr.append(subtract_td).append(addition_td).append(line_td)
          table.append(tr)
      )
      parent.append(table)
