define (require) ->
  Backbone = require('b')
  template = require('j!reporting/runs/error_log')
  T = require('utils/i18n.gettext')
  ErrorAccordion = require('views/reporting/runs/error_accordion')
  ErrorDetailsAccordionSection = require('views/reporting/runs/error_details_accordion_section')
  StacktraceAccordionSection = require('views/reporting/runs/stacktrace_accordion_section')

  class RunsErrorLogView extends Backbone.Layout
    template: template
    serialize: ->
      if @model.get("status") == "failure"
        {status: @model.get("status"), class_str: @model.get("data").exception.class + T(" had an error:"), message: @model.get("data").exception.message}

    afterRender: ->
      # nothing to render if there were no errors
      if @model.get("status") == "failure"
        sections = []
        if @model.get("data").exception.description.title?
          sections.push(new ErrorDetailsAccordionSection({name: "error_details", body: @model.get("data").exception.description}))

        sections.push(new StacktraceAccordionSection({name: "error_stacktrace", body: @model.get("data").exception.backtrace}))
        @setView(".accordion_container", new ErrorAccordion({parent: false, sections: sections})).render()
