define (require) ->
  Backbone    = require('b')
  RunListView = require('views/controls/run_list')
  Empty       = require('views/controls/empty')
  T           = require('utils/i18n.gettext')

  class RunsRunListView extends Backbone.Layout
    className: 'run-runlist runlist standalone panel'

    beforeRender: ->
      defaultEnv = new Backbone.Model({id: "_default"})
      run_list = []
      if @model.get("run_list").length > 0
        i = 0
        for entry in @model.get("run_list")
          recipe = {name: entry[1], position: i, type: entry[0]}
          run_list.push(recipe)
          if entry[0] != "role"
            i++
        defaultEnv.set("run_list", run_list)
        @model.run_lists().push(defaultEnv)
        @setView(new RunListView({
          collection: @model.run_lists()
          editable: false
        }))

    afterRender: ->
      if @model.get("run_list").length > 0
        # slightly hacky way of simply removing the run list version column
        # as we cannot currently get this info from reporting for runs
        @$("span.runlist-tree-version").html("")
      else
        @setView(new Empty).render()
