define (require) ->
  Role          = require('models/role')
  RunListEditor = require('views/controls/run_list_editor')
  T             = require('utils/i18n.gettext')
  JsonWizard    = require('views/controls/modals/json_wizard')
  template      = require('j!roles/modals/create')

  class CreateRoleWizard extends JsonWizard
    template: template
    title: T('Create Role')

    initialize: (options) ->
      @model = new Role({ run_list: [] })
      super()
      @model.collection = @app?.currentOrg?.roles

    beforeRender: ->
      super()
      @setView('.runList', new RunListEditor({
        environment: '_default',
        model: @model
        organization: @app.currentOrg
      }))

    onSaveError: (jqXHR, textStatus, errorThrown) =>
      @errorMessage = errorThrown
      @saveFailed = true
      @closeButtonText = T('Close')
      @render()
      # Hide additional wizard elements
      @$('.modal-subheader, nav.wizard').hide()
