define (require) ->
  $                   = require('jquery')
  Backbone            = require('b')
  BrowserVersionModal = require('views/application/modals/browser_version')
  SignUpForm          = require('models/sign_up_form')

  class SignUpView extends Backbone.Layout
    bindings:
      '#signup-username': 'username'
      '#signup-email': 'email'
      '#signup-display-name': 'display_name'
      '#signup-first-name': 'first_name'
      '#signup-last-name': 'last_name'
      '#signup-job-title': 'job_title'
      '#signup-company': 'company'
      '#signup-phone': 'phone'
      '#signup-organization': 'organization'
      '#signup-comment': 'comment'
      '#signup-terms': 'terms'

    events:
      'submit form': 'onSubmit'

    initialize: ->
      @model = new SignUpForm(ref: @$('input[name=ref]').val())

    afterRender: ->
      @bindValidation()
      # If needed, display the version warning
      new BrowserVersionModal

    onSubmit: (event) ->
      event.preventDefault()
      @model.validate().then(-> event.target.submit())
