define (require) ->
  BaseModal       = require('views/controls/modals/base')
  ErrorLineView   = require('views/controls/alerts/error_line')
  Spinner         = require('views/controls/spinner')
  SuccessLineView = require('views/controls/alerts/success_line')
  template        = require('j!users/modals/change_password')

  class ChangePasswordModal extends BaseModal
    template: template

    events:
      'click .submit': 'submit'

    bindings:
      '[name=current_password]': 'current_password'
      '[name=new_password]': 'new_password'
      '[name=new_password_confirmation]': 'new_password_confirmation'

    initialize: ->
      super()
      @model.on('validated', @toggleSubmit)

    afterRender: ->
      super()
      @bindValidation()

    submit: ->
      @model.validate().then =>
        @setView('.message', new Spinner).render()
        @model.sync('update', @model, {
          success: =>
            @setView('.message', new SuccessLineView({
              body: 'Password changed.'
            })).render()
            @$('button[data-dismiss=modal]').text('Close')
          error: (data) =>
            @setView('.message', new ErrorLineView({
              body: data.responseJSON?.error
            })).render()
            @$('button[data-dismiss=modal]').text('Cancel')
        })

    # Enable or disable the submit button based on the validity
    toggleSubmit: (model, result, isValid) =>
      @$('.submit').prop('disabled', !isValid)
