define (require) ->
  LeaveOrganizationModal = require('views/organizations/modals/leave')
  SuccessAlert = require('views/controls/alerts/success')

  class RemoveUserModal extends LeaveOrganizationModal
    className: "#{@::className} modal-remove-user"

    initialize: ->
      @user = @options.user
      @title = "Remove User from Organization"
      @subTitle = @user.id
      @commandText ?= "Remove User"
      super()

    body: ->
      "Are you certain you wish to remove <code>#{@user.id}</code> from the organization <code>#{@model.id}</code>? You would need to re-invite #{@user.id} to the organization and have #{@user.id} accept before he or she could be reinstated."

    ajaxData: ->
      {user: @user.id}

    userText: ->
      @user.id

    ajaxUrl: ->
      "#{@user.url()}/remove"

    successEvent: =>
      @$(".btn:eq(0)").html("Close")
      @$(".btn-warning").attr("disabled", true)
      @setView(".modal-body", new SuccessAlert({
        body: "<code>#{@user.id}</code> was successfully removed from <code>#{@model.id}</code>."
      })).render()
      @model.users.remove(@user)
      @trigger('remove-success')
