class ActionsController < ApplicationController
  # Force eager loading of all Worker classes so we can find them by name
  # ... but load the base class first
  require_dependency "base_worker"
  Dir["#{Rails.root}/app/workers/*.rb"].each { |path| require_dependency File.basename(path) }

  def index
    @actions = BaseWorker.for_organization(params[:organization_id]).each do |action|
      action['args'] = ActiveSupport::JSON.decode(action['args'])
    end
    render :json => @actions
  end

  def create
    @worker_class = BaseWorker.by_name(params[:action_id])
    unless @worker_class
      error_msg = {:error => true}
      error_msg[:actions] = BaseWorker.task_map.keys if Rails.env.development?
      return render :json => error_msg, :status => 404
    end
    @arguments = ActiveSupport::JSON.decode(params[:arguments])
    @jid = @worker_class.perform_async(session_username, params[:organization_id], *@arguments)
    render :json => {:id => @jid}
  end
end
