require 'changelog'

class ChangelogController < ApplicationController
  layout "outside"
  skip_before_action :check_for_password_reset
  skip_before_action :check_for_session_expiration
  skip_before_action :require_login

  def show
    path = Rails.root.join('CHANGELOG.md')

    @changelog = if File.exist?(path)
                   Changelog.new(File.read(path))
                 else
                   new_path = Rails.root.join('..', '..', 'CHANGELOG.md')
                   Changelog.new(File.read(new_path))
                 end

    respond_to do |format|
      format.html
      format.rss { render 'rss', layout: nil }
    end
  end
end
