class ChefServerApiController < ApplicationController

  def make_request(method)
    # Doing a case-split here since I observe
    #   server.request(:delete, params[:path], {}, params[:chef_server_api])
    # DoSing the chef-manage rails server (!?)

    case method
    when :get
      server.request(:get, params[:path] + "?" + request.query_string)
    when :delete
      server.request(:delete, params[:path])
    when :post
      server.request(:post, params[:path], {}, params[:chef_server_api])
    when :put
      server.request(:put, params[:path], {}, params[:chef_server_api])
    end
  end

  def show
    respond_to do |format|
      format.json { render :json => make_request(request.method_symbol) }
    end
  end
end
