class OrganizationAssociationRequestsController < ApplicationController
  def create
    invitation = server(session_username, params[:organziation_id]).post_rest(
      "association_requests", 'user' => params.fetch(:user)
    )

    # There is a case where an invitation can come back with a blank email
    # address. In this case we should return an OK response, but warn the user
    # that a message could not be sent.
    if invitation['user'] && invitation['user']['email'].blank?
      invitation.merge! 'warning' =>
        t('errors.messages.organization_association_requests.missing_email')
    else
      # If sending mail fails, the invitation will still be available upon
      # sign-in, but we'll want to warn about the mail having not been sent.
      begin
        OrganizationMailer.invite(invitation, login_url).deliver_now
      rescue Errno::ECONNREFUSED
        invitation.merge! 'warning' =>
          t('errors.messages.organization_association_requests.sending_failed')
      end
    end

    render :json => invitation
  end
end
