require 'dark_launch'

class SearchController < ApplicationController
  layout "alternate"
  before_action :check_dark_launch

  # An index of searches. Some kind of starting page to get you started with
  # search and/or list the types of indexes you can search on.
  def index
    @data = server.get_rest("search")

    respond_to do |format|
      format.json { render :json => @data }
      format.html
    end
  end

  # A search on a particular index. params[:id] is the type of index.
  def show
    @data = server.get_rest("search/#{params[:id]}?#{request.query_string}")

    respond_to do |format|
      format.json { render :json => @data }
      format.html
    end
  end

  private
  def check_dark_launch
    raise ::ActionController::RoutingError.new('Not Found') unless DarkLaunch.all_features(params[:organization_id])['search_dashboard']
  end
end
