class SystemRecoveriesController < ApplicationController
  skip_before_action :check_for_password_reset
  skip_before_action :check_for_session_expiration
  skip_before_action :require_login
  layout 'outside'

  # POST /system-recovery
  def create
    if params[:password].blank? || params[:username].blank?
      flash.now[:alert] = 'Username and password are required.'
      render 'show', status: :forbidden
      return
    else
      begin
        user = server_root.post_rest('system_recovery',
                                     username: params[:username],
                                     password: params[:password])
      rescue Net::HTTPServerException => e
        flash.now[:alert] = 'Incorrect username or password, or system recovery is not enabled for this account. If you think system recovery should work for your account, please contact your system administrator.'
        render 'show', status: e.response.code
        return
      end
      session[:username] = user['username']
      redirect_to root_path
    end
  end

  # GET /system-recovery
  def show
  end
end
