module PreloadHelpers
  def self.included(klass)
    klass.helper_method :preload_collection, :preload_object, :preload_skip_page
  end

  protected

  def preload_collection
    @preload_collection || controller_name
  end

  def preload_object
    if @preload_object
      @preload_object
    elsif @obj
      [@obj]
    elsif @objects
      # Skip the first page if we are preloading it, make sure to do this in subclasses if overridden
      @preload_skip_page = true
      @objects
    end
  end

  def preload_skip_page
    @preload_skip_page
  end

end
