require 'json'
require 'net/http'

module RecaptchaHelper
  def self.verify(response, secret, verify_url)
    verify_body = {
      "secret"    => secret,
      "response"  => response
    }

    query = URI.encode_www_form(verify_body)
    verify_uri = URI.parse("#{verify_url}?#{query}")
    request = Net::HTTP::Get.new(verify_uri.request_uri)
    res = Net::HTTP.start(verify_uri.host, verify_uri.port,
                          use_ssl: true) do |http|
      http.request(request)
    end

    JSON.parse(res.body)
  end
end
