class FeedbackMailer < ActionMailer::Base
  def initialize(*args)
    @config = Settings
    super
  end

  def send_email(subject, message, browser_info, app_state)
    @subject = "#{@config.feedback_email_subject_prefix} #{subject}"
    @message = message.strip
    @browser_info = browser_info
    @app_state = app_state

    mail mail_opts do |fmt|
      fmt.text { render layout: nil }
      fmt.html
    end
  end

  private
  def mail_opts
    @sender = if @app_state["email"].present?
                # Let Mail format the email address
                Mail::Address.new("%s %s <%s>" % @app_state.values_at("first_name", "last_name", "email"))
              end

    { :from => @config.feedback_email_default_from,
      :to => @config.feedback_email_to,
      :subject => @subject
    }.merge(@sender ? { reply_to: @sender } : {})
  end
end
