class PasswordResetMailer < ActionMailer::Base
  # Input:
  #   user: chef object returned by server
  #   expires: time limit before password reset link becomes invalid
  #   signature: password reset validation signature
  def password_reset(user, expires, signature)
    @user = user
    @expires = expires
    @signature = signature
    mail from: Settings.email_from_address,
         subject: "Reset Your #{Settings.chef_title} Password",
         to: @user['email']
  end
end
