# Worker tasks for Environments

require_dependency 'util_worker.rb'

module EnvironmentsWorkers
  class AttributesWorker < ::AttributesWorker
    task_abstract true
    def chef_url(environment_id)
      "environments/#{environment_id}"
    end

    def expire_attributes(environment_id)
      expire(:environments, environment_id)
    end
  end

  class DefaultAttributesWorker < AttributesWorker
    task_label 'Update environment default attributes'
    def update_attributes(environment, attributes)
      environment['default_attributes'] = attributes
    end
  end

  class OverrideAttributesWorker < AttributesWorker
    task_label 'Update environment override attributes'
    def update_attributes(environment, attributes)
      environment['override_attributes'] = attributes
    end
  end
end
