# Worker tasks for Roles

require_dependency 'util_worker.rb'

module RolesWorker

  class AttributesWorker < ::AttributesWorker
    task_abstract true
    def chef_url(role_id)
      "roles/#{role_id}"
    end

    def expire_attributes(role_id)
      expire(:roles, role_id)
    end
  end

  class DefaultAttributesWorker < AttributesWorker
    task_label 'Update role default attributes'
    def update_attributes(role, attributes)
      role['default_attributes'] = attributes
    end
  end

  class OverrideAttributesWorker < AttributesWorker
    task_label 'Update role override attributes'
    def update_attributes(role, attributes)
      role['override_attributes'] = attributes
    end
  end

  class EditRunListWorker < UtilWorker::EditRunListWorker
    def chef_url(object_id)
      "roles/#{object_id}"
    end

    def expire_run_list(object_id)
      expire(:roles, object_id)
    end
  end
end
