var system = require('system');
var page = require('webpage').create();
var url = system.args[1];

page.onConsoleMessage = function (message) {
  // I need to get some kind of message asynchronously from the page
  // context to the phantomjs context to signal that all (maybe
  // asynchronous) tests are done running, and this gross hack from
  // http://stackoverflow.com/questions/9479278/running-asynchronous-qunit-tests-from-ant-in-phantomjs
  // appears to work. If there's any better way of doing this I'd love
  // to know it. Googling around for "phantomjs asynchronous testing"
  // seems to produce mostly people complaining about it not working
  // nicely... in 2012 or so.

  if (message == "_DONE") {
    var failures = page.evaluate(function() { return window["test-failures"]; })
    if (failures == 0) {
      console.log("Tests succeeded.")
    }
    else {
      console.log("*** Tests failed! ***");
    }

    phantom.exit(failures ? 1 : 0);
  }
  else {
    console.log(message);
  }
};

function exit(code) {
  setTimeout(function(){ phantom.exit(code); }, 0);
  phantom.onError = function(){};
}

console.log("Loading URL: " + url);

page.open(url, function (status) {
  if (status != "success") {
    console.log('Failed to open ' + url);
    phantom.exit(1);
  }

  console.log("Running test.");

  var failures = page.evaluate(function() {
    try {
      test_runner.core.runner(function() { console.log("_DONE") });
    }
    catch (e) {
      console.log(e);
    }
  });
});
