(ns reagent-manage.error
  (:require [reagent.core :as reagent :refer [cursor]]
            [reagent.session :as session]))

(defn report
  "Set the current error to `err`."
  [err]  (session/put! :error err))

(defn alert
  "Component to render small bottom-of-page alert popup."
  [satm]
  (if-let [error (:error @satm)]
    [:div.alert-box.alert.bottom-alert {:data-alert true}
     (into [:span] error)
     [:a.close {:on-click #(report nil)} "×"]]
    [:span]))
