(ns reagent-manage.search-interface-test
  (:require
   [cljs.test :refer-macros [async deftest testing is]]
   [test-utils.react-utils :refer [get-html render contains]]
   [cljs.core.match :refer-macros [match]]
   [reagent.core :as reagent :refer [atom cursor]]
   [reagent-manage.search-interface :as search]
   [reagent-manage.api :as api]
   [reagent-manage.ajax :as ajax :refer [GET]])
  (:require-macros
   [cljs.core.async.macros :refer [go]]
   [reagent-manage.macros :refer [is-go]]))


(deftest base
  (testing "search results for data bags"
    (is (contains "databag-item"
                  (get-html (render [search/search-results
                                     (atom search/initial-search)
                                     {:index "some-unknown-databag"
                                      :results {:total 1 :rows [{:id "databag-item"}]}}])))))

  (async
   done
   (ajax/with-mocks
     (fn []
       (testing "ajax tests"
         (go
           (ajax/expect :POST ["/path"] 123)
           (is-go (= 123 (<! (api/request-absolute ajax/POST "/path"))))
           (done)))))))
