(ns reagent-manage.utils-test
  (:require [cljs.test :refer-macros [deftest testing is]]
            [reagent-manage.utils :as u]
            [test-utils.react-utils :as tu]))


(deftest base
  (testing "without-nth"
    (is (= (u/without-nth '[a b c d e f] 0) '[b c d e f]))
    (is (= (u/without-nth '[a b c d e f] 1) '[a c d e f]))
    (is (= (u/without-nth '[a b c d e f] 5) '[a b c d e]))
    (is (tu/expect-err #(u/without-nth '[a b c d e f] 6) "Index out of bounds"))
    (is (tu/expect-err #(u/without-nth '[a b c d e f] -1) "Index out of bounds")))

  (testing "indexify"
    (is (= (u/indexify '[a b c]) '[[0 a] [1 b] [2 c]]))

    ;; This one fails if indexify forgets to turn its input into a
    ;; vector to make `get` work:
    (is (= (u/indexify '(a b c)) '[[0 a] [1 b] [2 c]])))

  (testing "make-map"
    (is (= (u/make-map [[:a 1] [:b 2]]) {:a 1 :b 2})))

  (testing "set-toggle"
    (is (= (u/set-toggle #{1 2 3 4} 2) #{1 3 4}))
    (is (= (u/set-toggle #{1 2 3 4} 5) #{1 2 3 4 5})))

  )
