(ns test-runner.core
  (:use-macros
   [test-runner.core :only [run-tests-in-env]])
  (:require
   [cljs.test :as test :refer [report]]
   [reagent-manage.core-test]
   [reagent-manage.query-builder-test]
   [reagent-manage.utils-test]
   [reagent-manage.search-interface-test]))

(enable-console-print!)

;; Some test data that would otherwise be globally supplied by the
;; rails controller. May want to rethink how this is
;; provided/injected.
(aset js/window "chef"
      {:data {:client "https://api.opscode.piab/organizations/ponyville/search/client"
              :environment "https://api.opscode.piab/organizations/ponyville/search/environment"
              :node "https://api.opscode.piab/organizations/ponyville/search/node"
              :role "https://api.opscode.piab/organizations/ponyville/search/role"
              :saved-searches "https://api.opscode.piab/organizations/ponyville/search/saved-searches"}
       :organization_id "ponyville"})

(def test-completion-handler (atom #(do)))

(defmethod report [::test/default :summary] [m]
  (println "\nRan" (:test m) "tests containing"
           (+ (:pass m) (:fail m) (:error m)) "assertions.")
  (println (:fail m) "failures," (:error m) "errors.")
  (aset js/window "test-failures" (+ (:fail m) (:error m)))
  (@test-completion-handler))

(defn runner [k]
  (reset! test-completion-handler k)
  (run-tests-in-env ::test/default))
