Chef::Manage::Application.configure do
  # Settings specified here will take precedence over those in config/application.rb

  config.eager_load = false

  # In the development environment your application's code is reloaded on
  # every request. This slows down response time but is perfect for development
  # since you don't have to restart the web server when you make code changes.
  config.cache_classes = false

  # Log error messages when you accidentally call methods on nil.
  config.whiny_nils = true

  # Show full error reports and disable caching
  config.consider_all_requests_local       = true
  config.action_controller.perform_caching = false

  # Print deprecation notices to the Rails logger
  config.active_support.deprecation = :log

  # Only use best-standards-support built into browsers
  config.action_dispatch.best_standards_support = :builtin

  # Do not compress assets
  config.assets.compress = false
  config.assets.digest = false

  # Expands the lines which load the assets
  config.assets.debug = true

  config.assets.paths << Rails.root.join("spec", "javascripts")

  # MailCatcher for SMTP
  if Rails.const_defined?(:Server)
    config.action_mailer.default_url_options = {
      :host => "localhost:#{Rails::Server.new.options[:Port]}",
      :protocol => Settings.protocol,
    }
  end
  config.action_mailer.delivery_method = :smtp
  config.action_mailer.smtp_settings = { :address => "localhost", :port => 1025 }

  # Uncomment these lines to debug autoload errors
  # config.log_level = :error
  # config.logger.level = Logger::ERROR
  # ActiveSupport::Dependencies::logger = Logger.new(STDOUT)
  # ActiveSupport::Dependencies::log_activity = true
end
