# Load the privileged key as a constant to be used with the ChefRestHelpers
module ChefRestHelpers
  # Attempt to load a key. Warn if it does not exist.
  # When compiling assets when we're building packages, this file will not
  # exist and does not need to. If this file is missing in development or
  # production the application can start, but any requests to the Chef server
  # will fail.
  include SecretsHelpers
  begin
    KEY = Credentials.get("chef-server", "webui_key")
  rescue Veil::CredentialNotFound, Veil::GroupNotFound
    Rails.logger.warn "Unable to load webui_key (group \"chef-server\") from secret store (#{Settings.secrets}). Chef Infra Server requests will fail."
  end
end
