require 'uri'

ActiveSupport.on_load(:action_view) do
  Rails.application.config.assets.configure do |env|
    env.context_class.instance_eval do
      old_font_path = instance_method(:font_path)
      define_method(:font_path) do |source|
        uri = URI(source)
        server_uri = URI(old_font_path.bind(self).(uri.path))
        origin = Settings.origin
        server_uri.query = uri.query || ''
        if origin
          server_uri.query << '&' unless server_uri.query.empty?
          server_uri.query << origin
        end
        server_uri.fragment = uri.fragment
        server_uri.to_s
      end
    end
  end
end
