# Helper methods for the rails console
require 'chef_rest_helpers'

module Rails
  module ConsoleMethods
    include ChefRestHelpers

    def server(user=nil, organization=nil)
      super(user || @oc_user, organization || @oc_organization)
    end

    def perform_async(name, *args)
      worker_class = BaseWorker.by_name(name)
      if worker_class
        worker_class.perform_async(@oc_user, @oc_organization, *args)
      end
    end

    def login_as(user, organization)
      @oc_user = user
      @oc_organization = organization
    end

    # Make it look like a request
    def params
      {:organization_id => @oc_organization}
    end

    def session
      {:username => @oc_user}
    end
  end
end
