# When Rails parses JSON, it munges it with the deep_munge method to avoid
# malicious input into ActiveRecord. We're not using ActiveRecord, and this only
# causes problems getting data out of JSON input, especially free-from data like
# data bag items.
#
# See https://github.com/rails/rails/issues/13420
#
# Monkey patch deep_munge to be a no-op.
#
# Original: https://github.com/imanel/rails/blob/3-2-stable/actionpack/lib/action_dispatch/http/request.rb#L256-L270
class ActionDispatch::Request
  def deep_munge(hash)
    hash
  end
end
