require 'raven_settings'

Chef::Manage::Application.configure do
  Raven.configure do |raven|
    if RavenSettings.dsn.present?
      raven.dsn          = RavenSettings.dsn
      raven.environments = [Rails.env]
    else
      raven.environments = []
    end
    raven.logger           = Rails.logger
    raven.ssl_verification = false
    raven.processors       = [Raven::Processor::SanitizeData]

    # Ignore errors from the Chef server by default. We filter and selectively
    # send errors in the rescue_from handler in the application controller.
    raven.excluded_exceptions = Raven::Configuration::IGNORE_DEFAULT \
                              + ['Net::HTTPServerException']
  end
end
