# Class representing a config.rb file to be rendered and downloaded
class ConfigRb
  include ApplicationHelper
  attr_reader :orgname, :username

  def initialize(orgname, username)
    @username = username
    @orgname = orgname
  end

  def content_disposition
    "attachment; filename=\"#{filename}\""
  end

  def send_data_options
    { filename: filename }
  end

  def to_s
    template.result(binding)
  end

  private

  def filename
    'config.rb'
  end

  def template
    @template ||= ERB.new(
      open(
        "#{ApplicationController.view_paths.first}/organizations/config.rb.erb"
      ).read
    )
  end
end
