# Class describing a log level, for Rails or Chef
class LogLevel
  attr_reader :level

  def initialize(level)
    @level = level.to_s.downcase
  end

  def to_i
    return nil if level.blank?
    Logger::Severity.const_get(level.upcase)
  end

  def to_sym
    return nil if level.blank?
    level.to_sym
  end
end
