# Handles retrieving objects from a server including
# special cases like FORBIDDEN

class ObjectRetriever
  def self.get_object(args)

    id = args.fetch(:id)
    url = args.fetch(:url)
    server = args.fetch(:server)
    exception_type = args.fetch(:exception_type) { Net::HTTPServerException }

    begin
      result_hash = server.get_rest(url)
    rescue exception_type => e
      if e.response.code.to_i == 403
        result_hash = {"_id" => id, "forbidden" => true}
      else
        raise e
      end
    end
    result_hash
  end
end
