# Add configuration with publically usable DSN for Raven (Sentry)
class RavenSettings
  def self.dsn
    Settings.sentry.dsn
  end

  # In order to use the DSN on the client, we need it without the private key
  # (which is the password part of the URL.)
  def self.public_dsn
    dsn = Settings.sentry.public_dsn || self.dsn
    return '' if dsn.blank?
    uri = URI.parse(dsn)
    uri.password = nil
    uri.to_s
  end
end
