# Rake tasks for JavaScript specs
namespace :spec do
  namespace :javascripts do
    task :deps do
      # Only run `npm install` if node_modules is missing or if the NPM_INSTALL
      # environment variable is set. The environment variable lets Travis run
      # `npm install` and also cache the node_modules directory.
      if !Dir.exists?(Rails.root.join('node_modules')) || ENV['NPM_INSTALL'].present?
        system 'npm install' or exit($?.exitstatus)
      end
    end

    task :run => :deps do
      system 'npm test' or exit($?.exitstatus)
    end

    desc 'Watch javascript specs'
    task :watch => :deps do
      system 'npm run watch-test' or exit($?.exitstatus)
    end
  end
end

desc 'Run javascript specs'
task 'spec:javascripts' => 'spec:javascripts:run'

task default: 'spec:javascripts'
