(function() {
  var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  define(function(require) {
    var $, AboutModal, AdminController, Application, Backbone, BrowserVersionModal, JobQueue, LicenseInfo, Mainnav, NoOrganizationsModal, NodesParentController, Organizations, PoliciesController, ReportFeedback, ReportingController, SplitPane, UpgradeBannerView, User, Usernav, _, applicationTpl, config, router, state;
    $ = require('jquery');
    AboutModal = require('views/controls/modals/about');
    AdminController = require('controllers/admin');
    Backbone = require('b');
    BrowserVersionModal = require('views/application/modals/browser_version');
    JobQueue = require("services/job_queue");
    LicenseInfo = require('models/license_info');
    Mainnav = require('views/application/mainnav');
    NoOrganizationsModal = require('views/organizations/modals/no_organizations');
    NodesParentController = require('controllers/nodes_parent');
    Organizations = require('collections/organizations');
    PoliciesController = require('controllers/policies');
    ReportFeedback = require('views/controls/modals/report_feedback');
    ReportingController = require('controllers/reporting');
    router = require('router');
    SplitPane = require('views/application/split_pane');
    UpgradeBannerView = require('views/application/upgrade_banner');
    User = require('models/user');
    Usernav = require('views/application/usernav');
    _ = require('underscore');
    applicationTpl = require('j!application/application');
    config = require('config');
    state = require('state');
    return Application = (function(superClass) {
      extend(Application, superClass);

      function Application() {
        return Application.__super__.constructor.apply(this, arguments);
      }

      Application.prototype.template = applicationTpl;

      Application.prototype.events = {
        'click #logo': 'clickLogo',
        'click .leave-feedback': 'reportFeedback',
        'click #about-manage': 'aboutModal'
      };

      Application.prototype.initialize = function() {
        var j, len, org, ref, ref1, ref2;
        this.csrf_param = $('meta[name="csrf-param"]').attr('content');
        this.csrf_token = $('meta[name="csrf-token"]').attr('content');
        $.ajaxSetup({
          beforeSend: (function(_this) {
            return function(xhr, settings) {
              if (!settings.crossDomain && settings.type !== 'GET' && _this.csrf_token) {
                return xhr.setRequestHeader('X-CSRF-Token', _this.csrf_token);
              }
            };
          })(this)
        });
        $(document).ajaxError(function(event, jqXHR) {
          if (jqXHR.status === 401) {
            return $.ajax({
              url: '/logout',
              type: 'POST'
            }).always(function() {
              return window.location.reload();
            });
          }
        });
        router.route(/(.*?)\/+(\?.*)?$/, 'trailFix', function(url, params) {
          return this.navigate(this.toFragment(url, params), {
            trigger: true
          });
        });
        router.route('', 'root', (function(_this) {
          return function() {
            return _.defer(_.bind(_this.rootRoute, _this));
          };
        })(this));
        this.selection = new Backbone.Collection;
        this.splitPane = new SplitPane({
          app: this,
          selection: this.selection
        });
        this.masterQueue = new JobQueue({
          storeErrorQueue: true
        });
        this.setUpNavigationPrevention(this.masterQueue);
        ref = config.organizations || [];
        for (j = 0, len = ref.length; j < len; j++) {
          org = ref[j];
          org.app = this;
        }
        this.organizations = new Organizations(config.organizations);
        this.organizations.on('current:changed', (function(_this) {
          return function(org) {
            return _this.currentOrg = org;
          };
        })(this));
        this.currentOrg = this.organizations.last();
        if ((ref1 = window.Chef) != null) {
          if (typeof ref1.preload === "function") {
            ref1.preload(this.organizations);
          }
        }
        state.set({
          user: new User(config.user, {
            collection: (ref2 = this.currentOrg) != null ? ref2.users : void 0
          })
        });
        $(window).on('resize', $.proxy(this.onResize, this));
        if (!this.organizations.isEmpty()) {
          this.mainTabs = [
            new NodesParentController({
              app: this
            }), new ReportingController({
              app: this
            }), new PoliciesController({
              app: this
            }), new AdminController({
              app: this
            })
          ];
          this.usernav = new Usernav({
            app: this
          });
          this.mainnav = new Mainnav({
            el: false,
            app: this
          });
          return this.setViews({
            '#mainnav': this.mainnav,
            '#usernav': this.usernav
          });
        }
      };

      Application.prototype.serialize = function() {
        return {
          support_site_url: config.support_site_url,
          privacy_policy_url: config.privacy_policy_url,
          cookie_policy_url: config.cookie_policy_url
        };
      };

      Application.prototype.afterRender = function() {
        this.onResize();
        Backbone.history.start({
          pushState: true
        });
        new BrowserVersionModal({
          app: this
        });
        if (!config.disable_upgrade_banner) {
          this.licenseInfo = new LicenseInfo;
          this.upgradeBannerView = new UpgradeBannerView({
            el: this.$('#banner'),
            model: this.licenseInfo
          });
          this.listenTo(this.upgradeBannerView, 'afterRender', this.onResize);
          this.licenseInfo.fetch();
        }
        if (this.organizations.isEmpty()) {
          return new NoOrganizationsModal({
            app: this
          });
        }
      };

      Application.prototype.cleanup = function() {
        return $(window).off('resize', $.proxy(this.onResize, this));
      };

      Application.prototype.goToNoOrganizationsModal = function() {
        return new NoOrganizationsModal({
          app: this
        });
      };

      Application.prototype.onResize = function() {
        this.splitPane.resizePanes();
        return this.$('#content').css('top', this.$el.height());
      };

      Application.prototype.applyController = function(controller, splitPane, paneView) {
        var i, j, len, newSidebar, ref, ref1, section;
        state.set({
          controller: controller
        });
        $('body').attr('class', controller.id);
        this.mainnav.applyController(controller);
        this.usernav.applyController(controller);
        if (((ref = controller.collection) != null ? ref.url : void 0) && controller.collection.length === 0) {
          controller.collection.fetch();
        }
        newSidebar = controller.sidebarView();
        if (newSidebar !== this.sidebarView) {
          this.sidebarView = newSidebar;
          this.setView('#sidebar', this.sidebarView).render();
        }
        ref1 = this.sidebarView.sections;
        for (i = j = 0, len = ref1.length; j < len; i = ++j) {
          section = ref1[i];
          if (section.controller === controller) {
            this.sidebarView.openThisAndCloseAllOthers(this.$(section.el), {
              silent: true
            });
          }
        }
        if (splitPane != null ? splitPane : controller.split_pane) {
          if (this.paneView !== this.splitPane) {
            this.paneView = this.splitPane;
            this.setView('#panes', this.splitPane).render();
          }
          return this.splitPane.applyController(controller);
        } else {
          this.paneView = paneView != null ? paneView : _.result(controller, 'paneView');
          this.setView('#panes', this.paneView).render();
          this.splitPane.listViewClass = void 0;
          this.splitPane.objectViewClass = void 0;
          return this.splitPane.activeObjectView = void 0;
        }
      };

      Application.prototype.rootRoute = function() {
        var defaultTab, j, len, ref, tab;
        if (!this.organizations.isEmpty()) {
          ref = this.mainTabs;
          for (j = 0, len = ref.length; j < len; j++) {
            tab = ref[j];
            if (tab.checkAccess()) {
              defaultTab = tab;
              break;
            }
          }
          if (defaultTab) {
            return router.navigate(defaultTab.url(), {
              trigger: true
            });
          } else {
            return router.navigate(this.organizations.url(), {
              trigger: true
            });
          }
        }
      };

      Application.prototype.clickLogo = function(evt) {
        evt.preventDefault();
        return this.rootRoute();
      };

      Application.prototype.aboutModal = function(evt) {
        evt.preventDefault();
        return new AboutModal({
          app: this,
          collection: null
        });
      };

      Application.prototype.reportFeedback = function(evt) {
        evt.preventDefault();
        return new ReportFeedback({
          app: this,
          controller: state.get('controller')
        });
      };

      Application.prototype.isHosted = function() {
        return !config.private_chef;
      };

      Application.prototype.setUpNavigationPrevention = function(masterQueue) {
        (window.Chef || (window.Chef = {})).masterQueue = masterQueue;
        return window.onbeforeunload = function() {
          if (window.Chef.masterQueue.length() !== 0) {
            return 'You have background requests still waiting to be sent to the server for processing! If you leave the console, these requests will not be finished.';
          }
        };
      };

      return Application;

    })(Backbone.Layout);
  });

}).call(this);
